searchNodes=[{"doc":"Generate CSS and JS/TS assets for components. Setup Update mix.exs , adding the :surface compiler to the list of compilers: def project do [ ... , compilers : [ :phoenix ] ++ Mix . compilers ( ) ++ [ :surface ] ] end Configuration (optional) The Surface compiler provides some options for custom configuration in your config/dev.exs . Options hooks_output_dir - defines the folder where the compiler generates the JS hooks files. Default is ./assets/js/_hooks/ . css_output_file - defines the css file where the compiler generates the code. Default is ./assets/css/_components.css . Example config :surface , :compiler , hooks_output_dir : &quot;assets/js/surface&quot; , css_output_file : &quot;assets/css/surface.css&quot;","ref":"Mix.Tasks.Compile.Surface.html","title":"Mix.Tasks.Compile.Surface","type":"task"},{"doc":"","ref":"Mix.Tasks.Compile.Surface.ValidateComponents.html","title":"Mix.Tasks.Compile.Surface.ValidateComponents","type":"task"},{"doc":"","ref":"Mix.Tasks.Compile.Surface.ValidateComponents.html#validate/1","title":"Mix.Tasks.Compile.Surface.ValidateComponents.validate/1","type":"function"},{"doc":"Converts .sface files and ~F sigils from v0.7 to v0.8 syntax. mix surface . convert &quot;lib/**/*.{ex,exs,sface}&quot; &quot;test/**/*.{ex,exs}&quot; Please read the Migration Guide before running the converter and make sure you follow all required steps for a successful migration. Task-specific options The Surface formatter accepts a couple of the same task-specific options as mix format . Here are some examples of using these options: $ mix surface.convert --dot-formatter path/to/.formatter.exs You can also use the same syntax as mix format for specifying which files to convert: $ mix surface.convert path/to/file.ex &quot;lib/**/*.{ex,exs,sface}&quot; &quot;test/**/*.{ex,exs}&quot;","ref":"Mix.Tasks.Surface.Convert.html","title":"Mix.Tasks.Surface.Convert","type":"task"},{"doc":"Formatter Plugin Preferred To format Surface code using Elixir 1.13 or later, use Surface.Formatter.Plugin . Formats Surface ~F sigils and .sface files in the given files and patterns. $ mix surface.format &quot;lib/**/*.{ex,exs}&quot; &quot;test/**/*.{ex,exs}&quot; $ cat path/to/file.ex | mix surface.format - Takes the same options as mix format except for --check-equivalent . Formatting options Like mix format , the Surface formatter reads a .formatter.exs file in the current directory for formatter configuration. The Surface formatter accepts the same options as mix format . Read more about the expected format of .formatter.exs and the shared configuration options documented here . The Surface formatter also takes the following two additional options specified in .formatter.exs : :surface_line_length overrides :line_length only for mix surface.format ( :line_length is used otherwise, or defaults to 98) :surface_inputs overrides :inputs only for mix surface.format ( :inputs is used otherwise) Task-specific options The Surface formatter accepts the same task-specific options as mix format . Read documentation for the options documented here. . For quick reference, here are some examples of using these options: $ mix surface.format --check-formatted ** (Mix) mix surface.format failed due to --check-formatted. The following files are not formatted: * path/to/component.ex * path/to/file.sface $ mix surface.format --dry-run $ mix surface.format --dot-formatter path/to/.formatter.exs You can also use the same syntax as mix format for specifying which files to format: $ mix surface.format path/to/file.ex &quot;lib/**/*.{ex,exs}&quot; &quot;test/**/*.{ex,exs}&quot;","ref":"Mix.Tasks.Surface.Format.html","title":"Mix.Tasks.Surface.Format","type":"task"},{"doc":"Configures Surface on an phoenix project. This task is mostly meant to be used after bootstrapping a fresh Phoenix project using mix phx.new . Although it can also be used on existing non-fresh projects, some patches might not be applicable as they may depend on file content code/patterns that are no longer available. If such cases are detected, the task will inform which patches were skipped as well as provide instructions for manual configuration. $ mix surface.init Important note This task is still experimental . Make sure you have committed your work or have a proper backup before running it. As it may change a few files in the project, it's recommended to have a safe way to rollback the changes in case anything goes wrong. Options --catalogue - Configures the experimental Surface Catalogue for the project, which will be available at the /catalogue route. For more information see: https://github.com/surface-ui/surface_catalogue . --demo - Generates a sample &lt;Hero&gt; component. When used together with the --catalogue option, it additionally generates two catalogue examples and a playground for the component. --layouts - Replaces the generated .heex layouts with .sface files compatible with Surface. Warning: using this option always replaces the existing layouts, so any changes done in those layout files will be lost. It's recommended to use this option only on fresh projects. --tailwind - Configures the project to support Tailwind CSS, adding tailwind as a dependency, which will install tailwind's standalone CLI. That means no Node.js nor npm is required. When used together with the --catalogue , --demo and --layouts options, the related artefacts generated will be styled using Tailwind CSS instead of Milligram. --yes - automatic answer &quot;yes&quot; to all prompts. Warning: this will also say &quot;yes&quot; to overwrite existing files as well as fetching/installing dependencies, if required. --dry-run - does not save, delete or patch any file. --no-formatter - do not configure the Surface formatter. --no-js-hooks - do not configure automatic loading of colocated JS hook files. --no-scoped-css - do not configure scoped CSS for components. --no-error-tag - do not configure the ErrorTag component to use the ErrorHelpers.translate_error/1 function generated by mix phx.new when Gettext support is detected. --no-install - do not fetch and install added/updated dependencies. --web-module - Configures the name of the Web module. Defaults to MyAppWeb .","ref":"Mix.Tasks.Surface.Init.html","title":"Mix.Tasks.Surface.Init","type":"task"},{"doc":"Surface is a component based library for Phoenix LiveView . Built on top of the new Phoenix.LiveComponent API, Surface provides a more declarative way to express and use components in Phoenix. Full documentation and live examples can be found at surface-ui.org This module defines the ~F sigil that should be used to translate Surface code into Phoenix templates. In order to have ~F available for any Phoenix view, add the following import to your web file in lib/my_app_web.ex : # lib/my_app_web.ex ... def view do quote do ... import Surface end end Additionally, use Surface.init/1 in your mount function to initialize assigns used internally by surface: # A LiveView using surface templates defmodule PageLive do use Phoenix.LiveView import Surface def mount ( _params , _session , socket ) do socket = Surface . init ( socket ) ... { :ok , socket } end def render ( assigns ) do ~F&quot;&quot;&quot; ... &quot;&quot;&quot; end end # A LiveComponent using surface templates defmodule NavComponent do use Phoenix.LiveComponent import Surface def mount ( socket ) do socket = Surface . init ( socket ) ... { :ok , socket } end def render ( assigns ) do ~F&quot;&quot;&quot; ... &quot;&quot;&quot; end end Defining components To create a component you need to define a module and use one of the available component types: Surface.Component - A stateless component. Surface.LiveComponent - A live stateful component. Surface.LiveView - A wrapper component around Phoenix.LiveView . Surface.MacroComponent - A low-level component which is responsible for translating its own content at compile time. Example # A functional stateless component defmodule Button do use Surface.Component prop click , :event prop kind , :string , default : &quot;is-info&quot; def render ( assigns ) do ~F&quot;&quot;&quot; &lt;button class={&quot;button&quot;, @kind} :on-click={@click}&gt; &lt;#slot/&gt; &lt;/button&gt; &quot;&quot;&quot; end end You can visit the documentation of each type of component for further explanation and examples.","ref":"Surface.html","title":"Surface","type":"module"},{"doc":"","ref":"Surface.html#event_to_opts/2","title":"Surface.event_to_opts/2","type":"function"},{"doc":"Retrieve all component's config","ref":"Surface.html#get_components_config/0","title":"Surface.get_components_config/0","type":"function"},{"doc":"Retrieve the component's config based on the key","ref":"Surface.html#get_config/1","title":"Surface.get_config/1","type":"macro"},{"doc":"Retrieve a component's config based on the key","ref":"Surface.html#get_config/2","title":"Surface.get_config/2","type":"function"},{"doc":"Initialize surface state in the socket","ref":"Surface.html#init/1","title":"Surface.init/1","type":"function"},{"doc":"Converts the given code into Surface's AST. The code must be passed with the do block using the ~F sigil. Optional line , file and caller metadata can be passed using opts . Example iex&gt; [ tag ] = ...&gt; quote_surface do ...&gt; ~F&quot;&lt;div&gt;content&lt;/div&gt;&quot; ...&gt; end ...&gt; ...&gt; tag . children [ % Surface.AST.Literal { directives : [ ] , value : &quot;content&quot; } ]","ref":"Surface.html#quote_surface/2","title":"Surface.quote_surface/2","type":"macro"},{"doc":"Translates Surface code into Phoenix templates.","ref":"Surface.html#sigil_F/2","title":"Surface.sigil_F/2","type":"macro"},{"doc":"Tests if a slot has been filled in. Useful to avoid rendering unnecessary html tags that are used to wrap an optional slot in combination with :if directive. Examples &lt; div :if = { slot_assigned? ( :header ) } &gt; &lt; #slot {@header}/&gt; &lt; / div &gt;","ref":"Surface.html#slot_assigned?/1","title":"Surface.slot_assigned?/1","type":"macro"},{"doc":"Defines a stateless component. Example defmodule Button do use Surface.Component prop click , :event def render ( assigns ) do ~F&quot;&quot;&quot; &lt;button class=&quot;button&quot; :on-click={@click}&gt; &lt;#slot/&gt; &lt;/button&gt; &quot;&quot;&quot; end end Note : Stateless components cannot handle Phoenix LiveView events. If you need to handle them, please use a Surface.LiveComponent instead.","ref":"Surface.Component.html","title":"Surface.Component","type":"behaviour"},{"doc":"","ref":"Surface.Component.html#c:render/1","title":"Surface.Component.render/1","type":"callback"},{"doc":"An Elixir formatter plugin for Surface code. Elixir 1.13 introduced formatter plugins, allowing the Surface formatter to run during mix format instead of requiring developers to run mix surface.format separately. To format Surface code using Elixir 1.12 or earlier, use mix surface.format . .formatter.exs setup Add to :plugins in .formatter.exs in order to format ~F sigils and .sface files when running mix format . Only works on files matching patterns in :inputs , so add patterns for all Surface files to ensure they're formatted. # in .formatter.exs [ ... , import_deps : [ :surface ] , plugins : [ Surface.Formatter.Plugin ] , # add patterns matching all .sface files and all .ex files with ~F sigils inputs : [ &quot;*.{ex,exs}&quot; , &quot;{config,lib,test}/**/*.{ex,exs,sface}&quot; ] , # THE FOLLOWING ARE OPTIONAL: # set desired line length for both Elixir&#39;s code formatter and this one # (only affects opening tags in Surface) line_length : 80 , # or, set line length only for Surface code (overrides `line_length`) surface_line_length : 84 ] Options In .formatter.exs , the following options can be provided: :line_length - Maximum line length of an opening tag before SurfaceFormatter attempts to wrap it onto multiple lines. This option is used by Code.format_string!/2 and mix format and defaults to 98. :surface_line_length - Overrides :line_length ; useful for setting separate desired line length for Surface code and non-Surface Elixir code.","ref":"Surface.Formatter.Plugin.html","title":"Surface.Formatter.Plugin","type":"module"},{"doc":"Callback implementation for Mix.Tasks.Format.features/1 .","ref":"Surface.Formatter.Plugin.html#features/1","title":"Surface.Formatter.Plugin.features/1","type":"function"},{"doc":"Callback implementation for Mix.Tasks.Format.format/2 .","ref":"Surface.Formatter.Plugin.html#format/2","title":"Surface.Formatter.Plugin.format/2","type":"function"},{"doc":"A live stateful component. A wrapper around Phoenix.LiveComponent . Example defmodule Dialog do use Surface.LiveComponent prop title , :string , required : true def mount ( socket ) do { :ok , assign ( socket , show : false ) } end def render ( assigns ) do ~F&quot;&quot;&quot; &lt;div class={&quot;modal&quot;, &quot;is-active&quot;: @show}&gt; &lt;div class=&quot;modal-background&quot;&gt;&lt;/div&gt; &lt;div class=&quot;modal-card&quot;&gt; &lt;header class=&quot;modal-card-head&quot;&gt; &lt;p class=&quot;modal-card-title&quot;&gt;{@title}&lt;/p&gt; &lt;/header&gt; &lt;section class=&quot;modal-card-body&quot;&gt; &lt;#slot/&gt; &lt;/section&gt; &lt;footer class=&quot;modal-card-foot&quot; style=&quot;justify-content: flex-end&quot;&gt; &lt;Button click=&quot;hide&quot;&gt;Ok&lt;/Button&gt; &lt;/footer&gt; &lt;/div&gt; &lt;/div&gt; &quot;&quot;&quot; end # Public API def show ( dialog_id ) do send_update ( __MODULE__ , id : dialog_id , show : true ) end # Event handlers def handle_event ( &quot;show&quot; , _ , socket ) do { :noreply , assign ( socket , show : true ) } end def handle_event ( &quot;hide&quot; , _ , socket ) do { :noreply , assign ( socket , show : false ) } end end","ref":"Surface.LiveComponent.html","title":"Surface.LiveComponent","type":"module"},{"doc":"A wrapper component around Phoenix.LiveView . Since this module is just a wrapper around Phoenix.LiveView , you cannot define custom properties for it. Only :id and :session are available. However, built-in directives like :for and :if can be used normally. Example defmodule Example do use Surface.LiveView def render ( assigns ) do ~F&quot;&quot;&quot; &lt;Dialog title=&quot;Alert&quot; id=&quot;dialog&quot;&gt; This &lt;b&gt;Dialog&lt;/b&gt; is a stateful component. Cool! &lt;/Dialog&gt; &lt;Button click=&quot;show_dialog&quot;&gt;Click to open the dialog&lt;/Button&gt; &quot;&quot;&quot; end def handle_event ( &quot;show_dialog&quot; , _ , socket ) do Dialog . show ( &quot;dialog&quot; ) { :noreply , socket } end end","ref":"Surface.LiveView.html","title":"Surface.LiveView","type":"module"},{"doc":"Conveniences for testing Surface components.","ref":"Surface.LiveViewTest.html","title":"Surface.LiveViewTest","type":"module"},{"doc":"This macro generates ExUnit test cases for catalogue examples. The tests will automatically assert if the example was successfully rendered. Pay attention that, by default, the generated tests don't test how the components should look like. However, it makes sure the examples are not raising exceptions at runtime, for instance, due to changes in the component's API. Usage The catalogue_test/1 macro accepts a single argument which can one of: A component module (subject), which will generate tests for all examples/playgrounds found for that component. The atom :all , which will generate tests for all examples/playgrounds found for ALL components in the project. Keep in mind that you should either use individual catalogue_test/1 calls for each component or use :all . Otherwise, you will end up with duplicated tests. Options except - A list of modules that should be excluded. This option only applies when using :all . Examples Generating tests for components' examples: defmodule MyProject.Components.ButtonTest do use MyProject.ConnCase , async : true catalogue_test MyProject.Components.Button end Generating tests for all avaiable components: defmodule MyProject.Components.CatalogueTest do use MyProject.ConnCase , async : true catalogue_test :all end Generating tests for all avaiable components except MyComponent : defmodule MyProject.Components.CatalogueTest do use MyProject.ConnCase , async : true catalogue_test :all , except : [ MyComponent ] end","ref":"Surface.LiveViewTest.html#catalogue_test/2","title":"Surface.LiveViewTest.catalogue_test/2","type":"macro"},{"doc":"Compiles Surface code into a new LiveView module. This macro should be used sparingly as it always generates and compiles a new module on-the-fly, which can potentially slow down your test suite. Its main use is when testing compile-time errors/warnings. Example code = quote do ~F&quot;&quot;&quot; &lt;KeywordProp prop=&quot;some string&quot;/&gt; &quot;&quot;&quot; end message = ~S(code:1: invalid value for property &quot;prop&quot;. Expected a :keyword, got: &quot;some string&quot;.) assert_raise ( CompileError , message , fn -&gt; compile_surface ( code ) end )","ref":"Surface.LiveViewTest.html#compile_surface/2","title":"Surface.LiveViewTest.compile_surface/2","type":"macro"},{"doc":"Registers components that propagates context into its slots.","ref":"Surface.LiveViewTest.html#register_propagate_context_to_slots/1","title":"Surface.LiveViewTest.register_propagate_context_to_slots/1","type":"function"},{"doc":"Render Surface code. Use this macro when testing regular rendering of stateless components or live components that don't require a parent live view during the tests. For tests depending on the existence of a parent live view, e.g. testing events on live components and its side-effects, you need to use either Phoenix.LiveViewTest.live/2 or Phoenix.LiveViewTest.live_isolated/3 . Example html = render_surface do ~F&quot;&quot;&quot; &lt;Link label=&quot;user&quot; to=&quot;/users/1&quot; /&gt; &quot;&quot;&quot; end assert html =~ &quot;&quot;&quot; &lt;a href=&quot;/users/1&quot;&gt;user&lt;/a&gt; &quot;&quot;&quot;","ref":"Surface.LiveViewTest.html#render_surface/1","title":"Surface.LiveViewTest.render_surface/1","type":"macro"},{"doc":"Wraps a test code so it runs using a custom configuration for a given component. Tests using this macro should run synchronously. A warning is shown if the test case is configured as async: true . Example using_config TextInput , default_class : &quot;default_class&quot; do html = render_surface do ~F&quot;&quot;&quot; &lt;TextInput/&gt; &quot;&quot;&quot; end assert html =~ ~r/class=&quot;default_class&quot;/ end","ref":"Surface.LiveViewTest.html#using_config/3","title":"Surface.LiveViewTest.using_config/3","type":"macro"},{"doc":"A low-level component which is responsible for translating its own content at compile time.","ref":"Surface.MacroComponent.html","title":"Surface.MacroComponent","type":"behaviour"},{"doc":"Evaluates the values of the static properties of a macro component. Usually called inside translate/2 in order to retrieve the properties' values at compile-time.","ref":"Surface.MacroComponent.html#eval_static_props!/3","title":"Surface.MacroComponent.eval_static_props!/3","type":"function"},{"doc":"This function is called to expand a macro component into a set of Surface.AST nodes.","ref":"Surface.MacroComponent.html#c:expand/3","title":"Surface.MacroComponent.expand/3","type":"callback"},{"doc":"Use this module on regular Phoenix views to enable .sface templates Examples To make sface templates available on all your views, add to the view function on lib/your_app_web.ex : defmodule YourAppWeb do # ... def view do use Phoenix.View , root : &quot;lib/your_app_web/templates&quot; , namespace : YourAppWeb # ... use Surface.View , root : &quot;lib/your_app_web/templates&quot; end end If you want to make it available only on specific views, you can add a new function on the lib/your_app_web.ex : defmodule YourAppWeb do # ... def surface_view ( options \\ [ ] ) do [ view ( options ) , quote do use Surface.View , root : &quot;lib/your_app_web/templates&quot; end ] end end Then, replace use YourAppWeb, :view with use YourAppWeb, :surface_view on the views you want to enable sface templates.","ref":"Surface.View.html","title":"Surface.View","type":"module"},{"doc":"Returns the hash of all template paths for the given view. Used by Surface to check if a given view requires recompilation when a new template is added.","ref":"Surface.View.html#hash/2","title":"Surface.View.hash/2","type":"function"},{"doc":"A built-in module and component that allows users to set and retrieve values to/from the context. Properties put :context_put, accumulate: true, default: [] - Puts a value into the context. Usage &lt; Context put = { scope , values } &gt; ... &lt; / Context &gt; Where: scope - Optional. Is an atom representing the scope where the values will be stored. If no scope is provided, the value is stored at the root of the context map. values - A keyword list containing the key-value pairs that will be stored in the context. Examples With scope: &lt; Context put = { __MODULE__ , form : @form } &gt; ... &lt; / Context &gt; Without scope: &lt; Context put = { key1 : @value1 , key2 : &quot;some other value&quot; } &gt; ... &lt; / Context &gt; get :context_get, accumulate: true, default: [] - Retrieves a set of values from the context binding them to local variables. Usage &lt; Context get = { scope , bindings } &gt; ... &lt; / Context &gt; Where: scope - Optional. Is an atom representing the scope where the values will be stored. If no scope is provided, the value is stored at the root of the context map. bindings - A keyword list of bindings that will be retrieved from the context as local variables. Examples &lt; Context get = { Form , form : form } get = { Field , field : my_field } &gt; &lt; MyTextInput form = { form } field = { my_field } / &gt; &lt; / Context &gt; Slots default, required: true - The content of the &lt;Context&gt;","ref":"Surface.Components.Context.html","title":"Surface.Components.Context","type":"module"},{"doc":"Copies a value from the context directly into socket_or_assigns . Usage # Simple key Context . copy_assign ( socket_or_assigns , key ) # Simple key with options Context . copy_assign ( socket_or_assigns , key , opts ) # Key with scope Context . copy_assign ( socket_or_assigns , { scope , key } ) # Key with scope + options Context . copy_assign ( socket_or_assigns , { scope , key } , opts ) Options :as - Optional. The key to store the value. Default is the key without the scope.","ref":"Surface.Components.Context.html#copy_assign/3","title":"Surface.Components.Context.copy_assign/3","type":"function"},{"doc":"Retrieves a value from the context. Usage Context . get ( socket_or_assigns , scope , key ) Where: socket_or_assigns - The socket or assigns where the values will be retrieved from. scope - Optional. Is an atom representing the scope where the values will be stored. If no scope is provided, the value is stored at the root of the context map. key - the key to look for when retrieving the value. Examples form = Context . get ( assigns , Form , :form ) field = Context . get ( assigns , Field , :field ) ... ~F&quot;&quot;&quot; &lt;MyTextInput form={form} field={field} /&gt; &quot;&quot;&quot;","ref":"Surface.Components.Context.html#get/3","title":"Surface.Components.Context.get/3","type":"function"},{"doc":"","ref":"Surface.Components.Context.html#has_vars?/1","title":"Surface.Components.Context.has_vars?/1","type":"function"},{"doc":"Copies a value from the context directly into socket_or_assigns . It raises a runtime error in case the value is still nil after after the operation. This is useful whenever you expect a non-nil value coming either explicitly passed a prop or inplictly through the context. The value will be saved using the same key . Usage Context . maybe_copy_assign! ( socket_or_assigns , scope , key )","ref":"Surface.Components.Context.html#maybe_copy_assign!/3","title":"Surface.Components.Context.maybe_copy_assign!/3","type":"function"},{"doc":"Copies a value from the context directly into socket_or_assigns if the value hasn't already been set or if it's nil . The value will be saved using the same key . Usage Context . maybe_copy_assign ( socket_or_assigns , scope , key )","ref":"Surface.Components.Context.html#maybe_copy_assign/3","title":"Surface.Components.Context.maybe_copy_assign/3","type":"function"},{"doc":"Puts a value into the context. Usage Context . put ( socket_or_assigns , scope , values ) Where: socket_or_assigns - The socket or assigns where the values will be stored. scope - Optional. Is an atom representing the scope where the values will be stored. If no scope is provided, the value is stored at the root of the context map. values - A keyword list containing the key-value pairs that will be stored in the context. Examples With scope: Context . put ( __MODULE__ , form : @form ) Without scope: Context . put = ( key1 : @value1 , key2 : &quot;some other value&quot; )","ref":"Surface.Components.Context.html#put/3","title":"Surface.Components.Context.put/3","type":"function"},{"doc":"A built-in component that allows users to inject dynamic components into a Surface template. Properties module :module, required: true - The module of the component function :atom - The function of the component Slots default - The default slot","ref":"Surface.Components.Dynamic.Component.html","title":"Surface.Components.Dynamic.Component","type":"module"},{"doc":"Callback implementation for Surface.Component.render/1 .","ref":"Surface.Components.Dynamic.Component.html#render/1","title":"Surface.Components.Dynamic.Component.render/1","type":"function"},{"doc":"A built-in component that allows users to inject dynamic live components into a Surface template. Properties id :string, required: true - The id of the live component (required by LiveView for stateful components). module :module, required: true - The module of the component Slots default - The default slot","ref":"Surface.Components.Dynamic.LiveComponent.html","title":"Surface.Components.Dynamic.LiveComponent","type":"module"},{"doc":"Callback implementation for Phoenix.LiveComponent.mount/1 .","ref":"Surface.Components.Dynamic.LiveComponent.html#mount/1","title":"Surface.Components.Dynamic.LiveComponent.mount/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.render/1 .","ref":"Surface.Components.Dynamic.LiveComponent.html#render/1","title":"Surface.Components.Dynamic.LiveComponent.render/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.update/2 .","ref":"Surface.Components.Dynamic.LiveComponent.html#update/2","title":"Surface.Components.Dynamic.LiveComponent.update/2","type":"function"},{"doc":"Defines a form that lets the user submit information. Provides a wrapper for Phoenix.HTML.Form.form_for/3 . Additionally, adds the form instance that is returned by form_for/3 into the context, making it available to any child input. All options passed via opts will be sent to form_for/3 , for and action can be set directly and will override anything in opts . Properties id :string - The ID of the form attribute. If an ID is given, all form inputs will also be prefixed by the given ID. Required to enable form recovery following crashes or disconnects. for :any, required: true - Atom or changeset to inform the form data action :string, default: &quot;#&quot; - URL to where the form is submitted as :atom - The server side parameter in which all parameters will be gathered. method :string - Method to be used when submitting the form. multipart :boolean, default: false - When true, sets enctype to &quot;multipart/form-data&quot;. Required when uploading files. csrf_token :any - For &quot;post&quot; requests, the form tag will automatically include an input tag with name _csrf_token. When set to false, this is disabled. trigger_action :boolean - Trigger a standard form submit on DOM patch to the URL specified in the form's standard action attribute. This is useful to perform pre-final validation of a LiveView form submit before posting to a controller route for operations that require Plug session mutation. errors :keyword - Keyword list of errors for the form. opts :keyword, default: [] - Keyword list with options to be passed down to Phoenix.HTML.Tag.tag/2 class :css_class - Class or classes to apply to the form Slots default, arg: %{form: :form} - The content of the &lt;form&gt; Events change - Triggered when the form is changed submit - Triggered when the form is submitted auto_recover - Triggered when the form is being recovered. Use this event to enable specialized recovery when extra recovery handling on the server is required.","ref":"Surface.Components.Form.html","title":"Surface.Components.Form","type":"module"},{"doc":"Callback implementation for Surface.Component.render/1 .","ref":"Surface.Components.Form.html#render/1","title":"Surface.Components.Form.render/1","type":"function"},{"doc":"Generates a link to the given URL. Provides similar capabilities to Phoenix's built-in link/2 function. Options label and class can be set directly and will override anything in opts . All other options are forwarded to the underlying &lt;a&gt; tag. Examples &lt; Link label = &quot;user&quot; to = &quot;/users/1&quot; class = &quot;is-danger&quot; method = { :delete } opts = { data : [ confirm : &quot;Really?&quot; ] } / &gt; &lt; Link to = &quot;/users/1&quot; class = &quot;is-link&quot; &gt; &lt; span &gt; user &lt; / span &gt; &lt; / Link &gt; Properties values :keyword, default: [] - List values that will be sent as part of the payload triggered by an event to :any, required: true - The page to link to method :atom, default: :get - The method to use with the link id :string - Id to apply to the link class :css_class - Class or classes to apply to the link label :string - The label for the generated &lt;a&gt; element, if no content (default slot) is provided. opts :keyword, default: [] - Additional attributes to add onto the generated element Slots default - The content of the generated &lt;a&gt; element. If no content is provided, the value of property label is used instead. Events capture_click - Triggered when the component captures click click - Triggered when the component receives click window_focus - Triggered when the page receives focus window_blur - Triggered when the page loses focus focus - Triggered when the component receives focus blur - Triggered when the component loses focus window_keyup - Triggered when a key on the keyboard is released (window-level) window_keydown - Triggered when a key on the keyboard is pressed (window-level) keyup - Triggered when a key on the keyboard is released keydown - Triggered when a key on the keyboard is pressed","ref":"Surface.Components.Link.html","title":"Surface.Components.Link","type":"module"},{"doc":"Callback implementation for Surface.Component.render/1 .","ref":"Surface.Components.Link.html#render/1","title":"Surface.Components.Link.render/1","type":"function"},{"doc":"Generates a button that uses a regular HTML form to submit to the given URL. Useful to ensure that links that change data are not triggered by search engines and other spidering software. Provides similar capabilities to Phoenix's built-in button/2 function. Options label and class can be set directly and will override anything in opts . All other options are forwarded to the underlying &lt;button&gt; tag. Examples &lt; Button label = &quot;user&quot; to = &quot;/users/1&quot; class = &quot;is-danger&quot; method = { :delete } opts = { data : [ confirm : &quot;Really?&quot; ] } / &gt; &lt; Button to = &quot;/users/1&quot; class = &quot;is-link&quot; &gt; &lt; span &gt; user &lt; / span &gt; &lt; / Button &gt; Properties values :keyword, default: [] - List values that will be sent as part of the payload triggered by an event to :any, required: true - The page to link to method :atom, default: :post - The method to use with the button id :string - Id to apply to the button class :css_class - Class or classes to apply to the button label :string - The label for the generated &lt;button&gt; element, if no content (default slot) is provided. opts :keyword, default: [] - Additional attributes to add onto the generated element Slots default - The content of the generated &lt;button&gt; element. If no content is provided, the value of property label is used instead. Events capture_click - Triggered when the component captures click click - Triggered when the component receives click window_focus - Triggered when the page receives focus window_blur - Triggered when the page loses focus focus - Triggered when the component receives focus blur - Triggered when the component loses focus window_keyup - Triggered when a key on the keyboard is released (window-level) window_keydown - Triggered when a key on the keyboard is pressed (window-level) keyup - Triggered when a key on the keyboard is released keydown - Triggered when a key on the keyboard is pressed","ref":"Surface.Components.Link.Button.html","title":"Surface.Components.Link.Button","type":"module"},{"doc":"Callback implementation for Surface.Component.render/1 .","ref":"Surface.Components.Link.Button.html#render/1","title":"Surface.Components.Link.Button.render/1","type":"function"},{"doc":"Wrapper around Phoenix LiveView's built-in live_file_input/2 function. The parent LiveView, or LiveComponent must allow_uploads during mount: def mount ( socket ) do socket = allow_upload ( socket , :avatar , accept : ~w(.json) , max_entries : 1 ) { :ok , socket } end See Phoenix.LiveView Uploads documentation Properties values :keyword, default: [] - List values that will be sent as part of the payload triggered by an event upload :struct, required: true - Upload specified via allow_upload class :css_class - The CSS class for the generated &lt;input&gt; element opts :keyword, default: [] - Keyword list with options to be passed down to live_file_input/2 Events capture_click - Triggered when the component captures click click - Triggered when the component receives click window_focus - Triggered when the page receives focus window_blur - Triggered when the page loses focus focus - Triggered when the component receives focus blur - Triggered when the component loses focus window_keyup - Triggered when a key on the keyboard is released (window-level) window_keydown - Triggered when a key on the keyboard is pressed (window-level) keyup - Triggered when a key on the keyboard is released keydown - Triggered when a key on the keyboard is pressed","ref":"Surface.Components.LiveFileInput.html","title":"Surface.Components.LiveFileInput","type":"module"},{"doc":"Callback implementation for Surface.Component.render/1 .","ref":"Surface.Components.LiveFileInput.html#render/1","title":"Surface.Components.LiveFileInput.render/1","type":"function"},{"doc":"Defines a link that will patch the current LiveView. Provides similar capabilities to Phoenix's built-in live_patch/2 function. When navigating to the current LiveView, handle_params/3 is immediately invoked to handle the change of params and URL state. Then the new state is pushed to the client, without reloading the whole page. For live redirects to another LiveView, use &lt;LiveRedirect&gt; instead. Properties to :string, required: true - The required path to link to replace :boolean, default: false - The flag to replace the current history or push a new state class :css_class, default: &quot;&quot; - The CSS class for the generated &lt;a&gt; element label :string - The label for the generated &lt;a&gt; element, if no content (default slot) is provided. opts :keyword, default: [] - Additional attributes to add onto the generated element Slots default - The content of the generated &lt;a&gt; element. If no content is provided, the value of property label is used instead.","ref":"Surface.Components.LivePatch.html","title":"Surface.Components.LivePatch","type":"module"},{"doc":"Callback implementation for Surface.Component.render/1 .","ref":"Surface.Components.LivePatch.html#render/1","title":"Surface.Components.LivePatch.render/1","type":"function"},{"doc":"Defines a link that will redirect to a new LiveView. Provides similar capabilities to Phoenix's built-in live_redirect/2 function. The current LiveView will be shut down and a new one will be mounted in its place, without reloading the whole page. This can also be used to remount the same LiveView, in case you want to start fresh. If you want to navigate to the same LiveView without remounting it, use &lt;LivePatch&gt; instead. Properties to :string, required: true - The required path to link to replace :boolean, default: false - The flag to replace the current history or push a new state class :css_class, default: &quot;&quot; - The CSS class for the generated &lt;a&gt; element label :string - The label for the generated &lt;a&gt; element, if no content (default slot) is provided. opts :keyword, default: [] - Additional attributes to add onto the generated element Slots default - The content of the generated &lt;a&gt; element. If no content is provided, the value of property label is used instead.","ref":"Surface.Components.LiveRedirect.html","title":"Surface.Components.LiveRedirect","type":"module"},{"doc":"Callback implementation for Surface.Component.render/1 .","ref":"Surface.Components.LiveRedirect.html#render/1","title":"Surface.Components.LiveRedirect.render/1","type":"function"},{"doc":"A macro component that does not translate any of its contents. The content will be passed untouched to the underlying Phoenix's template engine. Note : By skipping translation, all Surface specific features are automatically disabled, including code interpolation with {...} , syntactic sugar for attributes and markup validation. Slots default - The content that will not be translated by Surface","ref":"Surface.Components.Raw.html","title":"Surface.Components.Raw","type":"module"},{"doc":"Callback implementation for Surface.MacroComponent.expand/3 .","ref":"Surface.Components.Raw.html#expand/3","title":"Surface.Components.Raw.expand/3","type":"function"},{"doc":"Defines a checkbox. Provides a wrapper for Phoenix.HTML.Form's checkbox/3 function. All options passed via opts will be sent to checkbox/3 , value and class can be set directly and will override anything in opts . Examples &lt; Checkbox form = &quot;user&quot; field = &quot;color&quot; opts = { autofocus : &quot;autofocus&quot; } / &gt; Properties values :keyword, default: [] - List values that will be sent as part of the payload triggered by an event form :form, from_context: {Surface.Components.Form, :form} - An identifier for the form field :any, from_context: {Surface.Components.Form.Field, :field} - An identifier for the input id :string - The id of the corresponding input field name :string - The name of the corresponding input field value :string - Value to pre-populated the input class :css_class - Class or classes to apply to the input opts :keyword, default: [] - Options list checked_value :any, default: true - The value to be sent when the checkbox is checked. Defaults to &quot;true&quot; hidden_input :boolean, default: true - Controls if this function will generate a hidden input to submit the unchecked value or not, defaults to &quot;true&quot;. unchecked_value :any, default: false - The value to be sent when the checkbox is unchecked, defaults to &quot;false&quot;. Events capture_click - Triggered when the component captures click click - Triggered when the component receives click window_focus - Triggered when the page receives focus window_blur - Triggered when the page loses focus focus - Triggered when the component receives focus blur - Triggered when the component loses focus window_keyup - Triggered when a key on the keyboard is released (window-level) window_keydown - Triggered when a key on the keyboard is pressed (window-level) keyup - Triggered when a key on the keyboard is released keydown - Triggered when a key on the keyboard is pressed","ref":"Surface.Components.Form.Checkbox.html","title":"Surface.Components.Form.Checkbox","type":"module"},{"doc":"Callback implementation for Surface.Component.render/1 .","ref":"Surface.Components.Form.Checkbox.html#render/1","title":"Surface.Components.Form.Checkbox.render/1","type":"function"},{"doc":"An input field that let the user specify a color , either with a text field or a color picker interface. Provides a wrapper for Phoenix.HTML.Form's color_input/3 function. All options passed via opts will be sent to color_input/3 , value and class can be set directly and will override anything in opts . Examples &lt; ColorInput form = &quot;user&quot; field = &quot;color&quot; opts = { autofocus : &quot;autofocus&quot; } / &gt; Properties values :keyword, default: [] - List values that will be sent as part of the payload triggered by an event form :form, from_context: {Surface.Components.Form, :form} - An identifier for the form field :any, from_context: {Surface.Components.Form.Field, :field} - An identifier for the input id :string - The id of the corresponding input field name :string - The name of the corresponding input field value :string - Value to pre-populated the input class :css_class - Class or classes to apply to the input opts :keyword, default: [] - Options list Events capture_click - Triggered when the component captures click click - Triggered when the component receives click window_focus - Triggered when the page receives focus window_blur - Triggered when the page loses focus focus - Triggered when the component receives focus blur - Triggered when the component loses focus window_keyup - Triggered when a key on the keyboard is released (window-level) window_keydown - Triggered when a key on the keyboard is pressed (window-level) keyup - Triggered when a key on the keyboard is released keydown - Triggered when a key on the keyboard is pressed","ref":"Surface.Components.Form.ColorInput.html","title":"Surface.Components.Form.ColorInput","type":"module"},{"doc":"Callback implementation for Surface.Component.render/1 .","ref":"Surface.Components.Form.ColorInput.html#render/1","title":"Surface.Components.Form.ColorInput.render/1","type":"function"},{"doc":"An input field that let the user enter a date , either with a text field or a date picker interface. Provides a wrapper for Phoenix.HTML.Form's date_input/3 function. All options passed via opts will be sent to date_input/3 , value and class can be set directly and will override anything in opts . Examples &lt; DateInput form = &quot;user&quot; field = &quot;birthday&quot; opts = { autofocus : &quot;autofocus&quot; } / &gt; Properties values :keyword, default: [] - List values that will be sent as part of the payload triggered by an event form :form, from_context: {Surface.Components.Form, :form} - An identifier for the form field :any, from_context: {Surface.Components.Form.Field, :field} - An identifier for the input id :string - The id of the corresponding input field name :string - The name of the corresponding input field value :string - Value to pre-populated the input class :css_class - Class or classes to apply to the input opts :keyword, default: [] - Options list Events capture_click - Triggered when the component captures click click - Triggered when the component receives click window_focus - Triggered when the page receives focus window_blur - Triggered when the page loses focus focus - Triggered when the component receives focus blur - Triggered when the component loses focus window_keyup - Triggered when a key on the keyboard is released (window-level) window_keydown - Triggered when a key on the keyboard is pressed (window-level) keyup - Triggered when a key on the keyboard is released keydown - Triggered when a key on the keyboard is pressed","ref":"Surface.Components.Form.DateInput.html","title":"Surface.Components.Form.DateInput","type":"module"},{"doc":"Callback implementation for Surface.Component.render/1 .","ref":"Surface.Components.Form.DateInput.html#render/1","title":"Surface.Components.Form.DateInput.render/1","type":"function"},{"doc":"Generates select tags for date. Provides a wrapper for Phoenix.HTML.Form's date_select/3 function. All options passed via opts will be sent to date_select/3 , value , default , year , month , day and builder can be set directly and will override anything in opts . Examples &lt; DateSelect form = &quot;user&quot; field = &quot;born_at&quot; / &gt; &lt; Form for = { :user } &gt; &lt; DateSelect field = { :born_at } / &gt; &lt; / Form &gt; Properties form :form, from_context: {Surface.Components.Form, :form} - The form identifier id :string - The id prefix for underlying select fields name :string - The name prefix for underlying select fields field :any, from_context: {Surface.Components.Form.Field, :field} - The field name value :any - Value to pre-populate the select default :any - Default value to use when none was given in 'value' and none is available in the form data year :keyword - Options passed to the underlying 'year' select month :keyword - Options passed to the underlying 'month' select day :keyword - Options passed to the underlying 'day' select builder :fun - Specify how the select can be build. It must be a function that receives a builder that should be invoked with the select name and a set of options. opts :keyword, default: [] - Options list","ref":"Surface.Components.Form.DateSelect.html","title":"Surface.Components.Form.DateSelect","type":"module"},{"doc":"Callback implementation for Surface.Component.render/1 .","ref":"Surface.Components.Form.DateSelect.html#render/1","title":"Surface.Components.Form.DateSelect.render/1","type":"function"},{"doc":"An input field that let the user enter both date and time , using a text field and a date picker interface. Provides a wrapper for Phoenix.HTML.Form's datetime_local_input/3 function. All options passed via opts will be sent to datetime_local_input/3 , value and class can be set directly and will override anything in opts . Examples &lt; DateTimeLocalInput form = &quot;order&quot; field = &quot;completed_at&quot; opts = { autofocus : &quot;autofocus&quot; } / &gt; Properties values :keyword, default: [] - List values that will be sent as part of the payload triggered by an event form :form, from_context: {Surface.Components.Form, :form} - An identifier for the form field :any, from_context: {Surface.Components.Form.Field, :field} - An identifier for the input id :string - The id of the corresponding input field name :string - The name of the corresponding input field value :string - Value to pre-populated the input class :css_class - Class or classes to apply to the input opts :keyword, default: [] - Options list Events capture_click - Triggered when the component captures click click - Triggered when the component receives click window_focus - Triggered when the page receives focus window_blur - Triggered when the page loses focus focus - Triggered when the component receives focus blur - Triggered when the component loses focus window_keyup - Triggered when a key on the keyboard is released (window-level) window_keydown - Triggered when a key on the keyboard is pressed (window-level) keyup - Triggered when a key on the keyboard is released keydown - Triggered when a key on the keyboard is pressed","ref":"Surface.Components.Form.DateTimeLocalInput.html","title":"Surface.Components.Form.DateTimeLocalInput","type":"module"},{"doc":"Callback implementation for Surface.Component.render/1 .","ref":"Surface.Components.Form.DateTimeLocalInput.html#render/1","title":"Surface.Components.Form.DateTimeLocalInput.render/1","type":"function"},{"doc":"Generates select tags for datetime. Provides a wrapper for Phoenix.HTML.Form's datetime_select/3 function. All options passed via opts will be sent to datetime_select/3 , value , default , year , month , day , hour , minute , second and builder can be set directly and will override anything in opts . Examples &lt; DateTimeSelect form = &quot;user&quot; field = &quot;born_at&quot; / &gt; &lt; Form for = { :user } &gt; &lt; DateTimeSelect field = { :born_at } / &gt; &lt; / Form &gt; Properties form :form, from_context: {Surface.Components.Form, :form} - The form identifier field :any, from_context: {Surface.Components.Form.Field, :field} - The field name id :string - The id prefix for underlying select fields name :string - The name prefix for underlying select fields value :any - Value to pre-populate the select default :any - Default value to use when none was given in 'value' and none is available in the form data year :keyword - Options passed to the underlying 'year' select month :keyword - Options passed to the underlying 'month' select day :keyword - Options passed to the underlying 'day' select hour :keyword - Options passed to the underlying 'day' select minute :keyword - Options passed to the underlying 'day' select second :keyword - Options passed to the underlying 'day' select builder :fun - Specify how the select can be build. It must be a function that receives a builder that should be invoked with the select name and a set of options. opts :keyword, default: [] - Options list","ref":"Surface.Components.Form.DateTimeSelect.html","title":"Surface.Components.Form.DateTimeSelect","type":"module"},{"doc":"Callback implementation for Surface.Component.render/1 .","ref":"Surface.Components.Form.DateTimeSelect.html#render/1","title":"Surface.Components.Form.DateTimeSelect.render/1","type":"function"},{"doc":"An input field that let the user enter one or multiple e-mails . Provides a wrapper for Phoenix.HTML.Form's email_input/3 function. All options passed via opts will be sent to email_input/3 , value and class can be set directly and will override anything in opts . Examples &lt; EmailInput form = &quot;user&quot; field = &quot;email&quot; opts = { autofocus : &quot;autofocus&quot; } / &gt; Properties values :keyword, default: [] - List values that will be sent as part of the payload triggered by an event form :form, from_context: {Surface.Components.Form, :form} - An identifier for the form field :any, from_context: {Surface.Components.Form.Field, :field} - An identifier for the input id :string - The id of the corresponding input field name :string - The name of the corresponding input field value :string - Value to pre-populated the input class :css_class - Class or classes to apply to the input opts :keyword, default: [] - Options list Events capture_click - Triggered when the component captures click click - Triggered when the component receives click window_focus - Triggered when the page receives focus window_blur - Triggered when the page loses focus focus - Triggered when the component receives focus blur - Triggered when the component loses focus window_keyup - Triggered when a key on the keyboard is released (window-level) window_keydown - Triggered when a key on the keyboard is pressed (window-level) keyup - Triggered when a key on the keyboard is released keydown - Triggered when a key on the keyboard is pressed","ref":"Surface.Components.Form.EmailInput.html","title":"Surface.Components.Form.EmailInput","type":"module"},{"doc":"Callback implementation for Surface.Component.render/1 .","ref":"Surface.Components.Form.EmailInput.html#render/1","title":"Surface.Components.Form.EmailInput.render/1","type":"function"},{"doc":"A component inspired by error_tag/3 that ships with mix phx.new in MyAppWeb.ErrorHelpers . Renders error messages if any exist regarding the given field. Error Translation Changeset errors are translated using the default error translator that ships with phoenix when generated with mix phx.new --no-gettext . When using Gettext, you can use configuration to route all errors through the MyAppWeb.ErrorHelpers.translate_error/1 function generated by Phoenix, which utilizes Gettext . You need to provide a tuple with the module and the name of the function (as an atom) as follows: config :surface , :components , [ { Surface.Components.Form.ErrorTag , default_translator : { MyAppWeb.ErrorHelpers , :translate_error } } ] Note: If you don't configure a default_translator , Surface will try to translate errors using a built-in message translator which may not cover all types of errors. If the error cannot be translated, a generic &quot;invalid value&quot; will be returned and a warning will be emitted, reminding the user to set up a proper default_translator that can handle such cases. There is also a translator prop which can be used on a case-by-case basis. It overrides the configuration. Examples &lt;ErrorTag field=&quot;password&quot; /&gt; &lt;Field name=&quot;password&quot;&gt; &lt;ErrorTag /&gt; &lt;/Field&gt; &lt;ErrorTag feedback_for=&quot;confirm_password_for_reset&quot; /&gt; &lt;ErrorTag class=&quot;custom-css-classes&quot; /&gt; &lt;ErrorTag translator={&amp;CustomTranslationLib.translate_error/1} /&gt; Properties form :form, from_context: {Surface.Components.Form, :form} - An identifier for the form field :any, from_context: {Surface.Components.Form.Field, :field} - An identifier for the associated field class :css_class - Classes to apply to each error tag &lt;span&gt;. This can also be set via config, for example: config :surface , :components , [ { Surface.Components.Form.ErrorTag , default_class : &quot;invalid-feedback&quot; } ] However, the prop overrides the config value if provided. translator :fun - A function that takes one argument {msg, opts} and returns the translated error message as a string. If not provided, falls back to Phoenix's default implementation. This can also be set via config, for example: config :surface , :components , [ { Surface.Components.Form.ErrorTag , default_translator : { MyApp.Gettext , :translate_error } } ] feedback_for :string - If you changed the default ID on the input, provide it here. (Useful when there are multiple forms on the same page, each with an input of the same name. LiveView will exhibit buggy behavior without assigning separate id's to each.)","ref":"Surface.Components.Form.ErrorTag.html","title":"Surface.Components.Form.ErrorTag","type":"module"},{"doc":"Callback implementation for Surface.Component.render/1 .","ref":"Surface.Components.Form.ErrorTag.html#render/1","title":"Surface.Components.Form.ErrorTag.render/1","type":"function"},{"doc":"Translates an error message. This is the fallback (Phoenix's default implementation) if a translator is not provided via config or the translate prop.","ref":"Surface.Components.Form.ErrorTag.html#translate_error/1","title":"Surface.Components.Form.ErrorTag.translate_error/1","type":"function"},{"doc":"Defines a form field. The Field component sets the provided field name into the context so child components like input fields and labels can retrieve it and use it as the default field. Properties name :any, required: true - The field name class :css_class - The CSS class for the generated &lt;div&gt; element Slots default, required: true - The content for the field","ref":"Surface.Components.Form.Field.html","title":"Surface.Components.Form.Field","type":"module"},{"doc":"Callback implementation for Surface.Component.render/1 .","ref":"Surface.Components.Form.Field.html#render/1","title":"Surface.Components.Form.Field.render/1","type":"function"},{"doc":"Defines a context for a form field but without the &lt;div&gt; wrapper in Field . Like the Field component, sets the provided field name into the context so child components like input fields and labels can retrieve it and use it as the default field. Properties name :any, required: true - The field name Slots default, required: true - The content for the field","ref":"Surface.Components.Form.FieldContext.html","title":"Surface.Components.Form.FieldContext","type":"module"},{"doc":"Callback implementation for Surface.Component.render/1 .","ref":"Surface.Components.Form.FieldContext.html#render/1","title":"Surface.Components.Form.FieldContext.render/1","type":"function"},{"doc":"Generates a file input. It requires the given form to be configured with multipart: true . All options passed via opts will be sent to file_input/3 , value and class can be set directly and will override anything in opts . Examples &lt; Form for = { :user } multipart = { true } &gt; &lt; FileInput field = { :picture } / &gt; &lt; / Form &gt; Properties values :keyword, default: [] - List values that will be sent as part of the payload triggered by an event form :form, from_context: {Surface.Components.Form, :form} - An identifier for the form field :any, from_context: {Surface.Components.Form.Field, :field} - An identifier for the input id :string - The id of the corresponding input field name :string - The name of the corresponding input field value :string - Value to pre-populated the input class :css_class - Class or classes to apply to the input opts :keyword, default: [] - Options list Events capture_click - Triggered when the component captures click click - Triggered when the component receives click window_focus - Triggered when the page receives focus window_blur - Triggered when the page loses focus focus - Triggered when the component receives focus blur - Triggered when the component loses focus window_keyup - Triggered when a key on the keyboard is released (window-level) window_keydown - Triggered when a key on the keyboard is pressed (window-level) keyup - Triggered when a key on the keyboard is released keydown - Triggered when a key on the keyboard is pressed","ref":"Surface.Components.Form.FileInput.html","title":"Surface.Components.Form.FileInput","type":"module"},{"doc":"Callback implementation for Surface.Component.render/1 .","ref":"Surface.Components.Form.FileInput.html#render/1","title":"Surface.Components.Form.FileInput.render/1","type":"function"},{"doc":"A hidden input field. Provides a wrapper for Phoenix.HTML.Form's hidden_input/3 function. All options passed via opts will be sent to hidden_input/3 , value and class can be set directly and will override anything in opts . Examples &lt; HiddenInput form = &quot;user&quot; field = &quot;token&quot; opts = { autofocus : &quot;autofocus&quot; } / &gt; Properties values :keyword, default: [] - List values that will be sent as part of the payload triggered by an event form :form, from_context: {Surface.Components.Form, :form} - An identifier for the form field :any, from_context: {Surface.Components.Form.Field, :field} - An identifier for the input id :string - The id of the corresponding input field name :string - The name of the corresponding input field value :string - Value to pre-populated the input class :css_class - Class or classes to apply to the input opts :keyword, default: [] - Options list Events capture_click - Triggered when the component captures click click - Triggered when the component receives click window_focus - Triggered when the page receives focus window_blur - Triggered when the page loses focus focus - Triggered when the component receives focus blur - Triggered when the component loses focus window_keyup - Triggered when a key on the keyboard is released (window-level) window_keydown - Triggered when a key on the keyboard is pressed (window-level) keyup - Triggered when a key on the keyboard is released keydown - Triggered when a key on the keyboard is pressed","ref":"Surface.Components.Form.HiddenInput.html","title":"Surface.Components.Form.HiddenInput","type":"module"},{"doc":"Callback implementation for Surface.Component.render/1 .","ref":"Surface.Components.Form.HiddenInput.html#render/1","title":"Surface.Components.Form.HiddenInput.render/1","type":"function"},{"doc":"A wrapper for Phoenix.HTML.Form.html.hidden_inputs_for/1 . Generates hidden inputs for the given form. Properties for :form, from_context: {Surface.Components.Form, :form} - The form. It should either be a Phoenix.HTML.Form emitted by form_for , inputs_for or an atom.","ref":"Surface.Components.Form.HiddenInputs.html","title":"Surface.Components.Form.HiddenInputs","type":"module"},{"doc":"Callback implementation for Surface.Component.render/1 .","ref":"Surface.Components.Form.HiddenInputs.html#render/1","title":"Surface.Components.Form.HiddenInputs.render/1","type":"function"},{"doc":"Properties assigns :map - The assigns of the host component Slots default, arg: %{form: :form, field: :any} - The code containing the input control","ref":"Surface.Components.Form.Input.InputContext.html","title":"Surface.Components.Form.Input.InputContext","type":"module"},{"doc":"Callback implementation for Surface.Component.render/1 .","ref":"Surface.Components.Form.Input.InputContext.html#render/1","title":"Surface.Components.Form.Input.InputContext.render/1","type":"function"},{"doc":"A wrapper for Phoenix.HTML.Form.html.inputs_for/3 . Additionally, adds the generated form instance that is returned by inputs_for/3 into the context, making it available to any child input. Properties form :form, from_context: {Form, :form} - The parent form. It should either be a Phoenix.HTML.Form emitted by form_for or an atom. for :any, from_context: {Field, :field} - An atom or string representing the field related to the child inputs. opts :keyword, default: [] - Extra options for inputs_for/3 . See Phoenix.HTML.Form.html.inputs_for/4 for the available options. Slots default, arg: %{form: :form, index: :integer} - The code containing the input controls","ref":"Surface.Components.Form.Inputs.html","title":"Surface.Components.Form.Inputs","type":"module"},{"doc":"Callback implementation for Surface.Component.render/1 .","ref":"Surface.Components.Form.Inputs.html#render/1","title":"Surface.Components.Form.Inputs.render/1","type":"function"},{"doc":"Defines a label. Provides similar capabilities to Phoenix's built-in label/2 function. Option class can be set directly and will override anything in opts . All given options are forwarded to the underlying tag. A default value is provided for for attribute but can be overridden if you pass a value to the for option. Text content would be inferred from field if not specified. Properties values :keyword, default: [] - List values that will be sent as part of the payload triggered by an event form :form, from_context: {Surface.Components.Form, :form} - The form identifier field :any, from_context: {Surface.Components.Form.Field, :field} - The field name class :css_class - The CSS class for the underlying tag text :any - The text for the generated &lt;label&gt; element, if no content (default slot) is provided. opts :keyword, default: [] - Options list Slots default - The text for the label Events capture_click - Triggered when the component captures click click - Triggered when the component receives click window_focus - Triggered when the page receives focus window_blur - Triggered when the page loses focus focus - Triggered when the component receives focus blur - Triggered when the component loses focus window_keyup - Triggered when a key on the keyboard is released (window-level) window_keydown - Triggered when a key on the keyboard is pressed (window-level) keyup - Triggered when a key on the keyboard is released keydown - Triggered when a key on the keyboard is pressed","ref":"Surface.Components.Form.Label.html","title":"Surface.Components.Form.Label","type":"module"},{"doc":"Callback implementation for Surface.Component.render/1 .","ref":"Surface.Components.Form.Label.html#render/1","title":"Surface.Components.Form.Label.render/1","type":"function"},{"doc":"Defines a select. Provides a wrapper for Phoenix.HTML.Form's multiple_select/4 function. All options passed via opts will be sent to multiple_select/4 , class can be set directly and will override anything in opts . Properties form :form, from_context: {Surface.Components.Form, :form} - The form identifier field :any, from_context: {Surface.Components.Form.Field, :field} - The field name id :string - The id of the corresponding select field name :string - The name of the corresponding select field class :css_class - The CSS class for the underlying tag options :any, default: [] - The options in the select selected :any - The default selected option opts :keyword, default: [] - Options list","ref":"Surface.Components.Form.MultipleSelect.html","title":"Surface.Components.Form.MultipleSelect","type":"module"},{"doc":"Callback implementation for Surface.Component.render/1 .","ref":"Surface.Components.Form.MultipleSelect.html#render/1","title":"Surface.Components.Form.MultipleSelect.render/1","type":"function"},{"doc":"An input field that let the user to enter a number . Provides a wrapper for Phoenix.HTML.Form's number_input/3 function. All options passed via opts will be sent to number_input/3 , value and class can be set directly and will override anything in opts . Examples &lt; NumberInput form = &quot;user&quot; field = &quot;age&quot; opts = { autofocus : &quot;autofocus&quot; } / &gt; Properties values :keyword, default: [] - List values that will be sent as part of the payload triggered by an event form :form, from_context: {Surface.Components.Form, :form} - An identifier for the form field :any, from_context: {Surface.Components.Form.Field, :field} - An identifier for the input id :string - The id of the corresponding input field name :string - The name of the corresponding input field value :string - Value to pre-populated the input class :css_class - Class or classes to apply to the input opts :keyword, default: [] - Options list Events capture_click - Triggered when the component captures click click - Triggered when the component receives click window_focus - Triggered when the page receives focus window_blur - Triggered when the page loses focus focus - Triggered when the component receives focus blur - Triggered when the component loses focus window_keyup - Triggered when a key on the keyboard is released (window-level) window_keydown - Triggered when a key on the keyboard is pressed (window-level) keyup - Triggered when a key on the keyboard is released keydown - Triggered when a key on the keyboard is pressed","ref":"Surface.Components.Form.NumberInput.html","title":"Surface.Components.Form.NumberInput","type":"module"},{"doc":"Callback implementation for Surface.Component.render/1 .","ref":"Surface.Components.Form.NumberInput.html#render/1","title":"Surface.Components.Form.NumberInput.render/1","type":"function"},{"doc":"Defines options to be used inside a select. This is useful when building the select by hand. Provides a wrapper for Phoenix.HTML.Form's options_for_select/2 function. Properties options :any, default: [] - The options in the select selected :any, default: nil - The selected values","ref":"Surface.Components.Form.OptionsForSelect.html","title":"Surface.Components.Form.OptionsForSelect","type":"module"},{"doc":"Callback implementation for Surface.Component.render/1 .","ref":"Surface.Components.Form.OptionsForSelect.html#render/1","title":"Surface.Components.Form.OptionsForSelect.render/1","type":"function"},{"doc":"An input field that let the user securely specify a password . Provides a wrapper for Phoenix.HTML.Form's password_input/3 function. All options passed via opts will be sent to password_input/3 , value and class can be set directly and will override anything in opts . Examples &lt; PasswordInput form = &quot;user&quot; field = &quot;password&quot; opts = { autofocus : &quot;autofocus&quot; } / &gt; Properties values :keyword, default: [] - List values that will be sent as part of the payload triggered by an event form :form, from_context: {Surface.Components.Form, :form} - An identifier for the form field :any, from_context: {Surface.Components.Form.Field, :field} - An identifier for the input id :string - The id of the corresponding input field name :string - The name of the corresponding input field value :string - Value to pre-populated the input class :css_class - Class or classes to apply to the input opts :keyword, default: [] - Options list Events capture_click - Triggered when the component captures click click - Triggered when the component receives click window_focus - Triggered when the page receives focus window_blur - Triggered when the page loses focus focus - Triggered when the component receives focus blur - Triggered when the component loses focus window_keyup - Triggered when a key on the keyboard is released (window-level) window_keydown - Triggered when a key on the keyboard is pressed (window-level) keyup - Triggered when a key on the keyboard is released keydown - Triggered when a key on the keyboard is pressed","ref":"Surface.Components.Form.PasswordInput.html","title":"Surface.Components.Form.PasswordInput","type":"module"},{"doc":"Callback implementation for Surface.Component.render/1 .","ref":"Surface.Components.Form.PasswordInput.html#render/1","title":"Surface.Components.Form.PasswordInput.render/1","type":"function"},{"doc":"Defines a radio button. Provides a wrapper for Phoenix.HTML.Form's radio_button/4 function. All options passed via opts will be sent to radio_button/4 , value and class can be set directly and will override anything in opts . Examples &lt; RadioButton form = &quot;user&quot; field = &quot;color&quot; opts = { autofocus : &quot;autofocus&quot; } / &gt; Properties values :keyword, default: [] - List values that will be sent as part of the payload triggered by an event form :form, from_context: {Surface.Components.Form, :form} - An identifier for the form field :any, from_context: {Surface.Components.Form.Field, :field} - An identifier for the input id :string - The id of the corresponding input field name :string - The name of the corresponding input field value :string - Value to pre-populated the input class :css_class - Class or classes to apply to the input opts :keyword, default: [] - Options list checked :boolean - Indicates whether or not the radio button is the selected item in the group Events capture_click - Triggered when the component captures click click - Triggered when the component receives click window_focus - Triggered when the page receives focus window_blur - Triggered when the page loses focus focus - Triggered when the component receives focus blur - Triggered when the component loses focus window_keyup - Triggered when a key on the keyboard is released (window-level) window_keydown - Triggered when a key on the keyboard is pressed (window-level) keyup - Triggered when a key on the keyboard is released keydown - Triggered when a key on the keyboard is pressed","ref":"Surface.Components.Form.RadioButton.html","title":"Surface.Components.Form.RadioButton","type":"module"},{"doc":"Callback implementation for Surface.Component.render/1 .","ref":"Surface.Components.Form.RadioButton.html#render/1","title":"Surface.Components.Form.RadioButton.render/1","type":"function"},{"doc":"An input field that let the user specify a numeric value in a given range , usually using a slider. Provides a wrapper for Phoenix.HTML.Form's range_input/3 function. All options passed via opts will be sent to range_input/3 , value , min , max and class can be set directly and will override anything in opts . Examples &lt; RangeInput form = &quot;volume&quot; field = &quot;percent&quot; min = &quot;0&quot; max = &quot;100&quot; step = &quot;5&quot; value = &quot;40&quot; opts = { autofocus : &quot;autofocus&quot; } / &gt; Properties values :keyword, default: [] - List values that will be sent as part of the payload triggered by an event form :form, from_context: {Surface.Components.Form, :form} - An identifier for the form field :any, from_context: {Surface.Components.Form.Field, :field} - An identifier for the input id :string - The id of the corresponding input field name :string - The name of the corresponding input field value :string - Value to pre-populated the input class :css_class - Class or classes to apply to the input opts :keyword, default: [] - Options list min :string - Minimum value for the input max :string - Maximum value for the input step :string - Sets or returns the value of the step attribute of the slider control Events capture_click - Triggered when the component captures click click - Triggered when the component receives click window_focus - Triggered when the page receives focus window_blur - Triggered when the page loses focus focus - Triggered when the component receives focus blur - Triggered when the component loses focus window_keyup - Triggered when a key on the keyboard is released (window-level) window_keydown - Triggered when a key on the keyboard is pressed (window-level) keyup - Triggered when a key on the keyboard is released keydown - Triggered when a key on the keyboard is pressed","ref":"Surface.Components.Form.RangeInput.html","title":"Surface.Components.Form.RangeInput","type":"module"},{"doc":"Callback implementation for Surface.Component.render/1 .","ref":"Surface.Components.Form.RangeInput.html#render/1","title":"Surface.Components.Form.RangeInput.render/1","type":"function"},{"doc":"Defines a reset button. Provides a wrapper for Phoenix.HTML.Form's reset/2 function. All options passed via opts will be sent to reset/2 , value and class can be set directly and will override anything in opts . Examples &lt; Reset value = &quot;Reset&quot; opts = { autofocus : &quot;autofocus&quot; } / &gt; Properties values :keyword, default: [] - List values that will be sent as part of the payload triggered by an event id :string - The id of the corresponding input field name :string - The name of the corresponding input field value :string, default: &quot;Reset&quot; - Value to pre-populated the input class :css_class - Class or classes to apply to the input opts :keyword, default: [] - Keyword list with options to be passed down to reset/2 Events capture_click - Triggered when the component captures click click - Triggered when the component receives click window_focus - Triggered when the page receives focus window_blur - Triggered when the page loses focus focus - Triggered when the component receives focus blur - Triggered when the component loses focus window_keyup - Triggered when a key on the keyboard is released (window-level) window_keydown - Triggered when a key on the keyboard is pressed (window-level) keyup - Triggered when a key on the keyboard is released keydown - Triggered when a key on the keyboard is pressed","ref":"Surface.Components.Form.Reset.html","title":"Surface.Components.Form.Reset","type":"module"},{"doc":"Callback implementation for Surface.Component.render/1 .","ref":"Surface.Components.Form.Reset.html#render/1","title":"Surface.Components.Form.Reset.render/1","type":"function"},{"doc":"An input field that let the user enter search queries. Provides a wrapper for Phoenix.HTML.Form's search_input/3 function. All options passed via opts will be sent to search_input/3 , value and class can be set directly and will override anything in opts . Examples &lt; SearchInput form = &quot;song&quot; field = &quot;title&quot; opts = { autofocus : &quot;autofocus&quot; } / &gt; Properties values :keyword, default: [] - List values that will be sent as part of the payload triggered by an event form :form, from_context: {Surface.Components.Form, :form} - An identifier for the form field :any, from_context: {Surface.Components.Form.Field, :field} - An identifier for the input id :string - The id of the corresponding input field name :string - The name of the corresponding input field value :string - Value to pre-populated the input class :css_class - Class or classes to apply to the input opts :keyword, default: [] - Options list Events capture_click - Triggered when the component captures click click - Triggered when the component receives click window_focus - Triggered when the page receives focus window_blur - Triggered when the page loses focus focus - Triggered when the component receives focus blur - Triggered when the component loses focus window_keyup - Triggered when a key on the keyboard is released (window-level) window_keydown - Triggered when a key on the keyboard is pressed (window-level) keyup - Triggered when a key on the keyboard is released keydown - Triggered when a key on the keyboard is pressed","ref":"Surface.Components.Form.SearchInput.html","title":"Surface.Components.Form.SearchInput","type":"module"},{"doc":"Callback implementation for Surface.Component.render/1 .","ref":"Surface.Components.Form.SearchInput.html#render/1","title":"Surface.Components.Form.SearchInput.render/1","type":"function"},{"doc":"Defines a select. Provides a wrapper for Phoenix.HTML.Form's select/4 function. All options passed via opts will be sent to select/4 , class can be set directly and will override anything in opts . Properties form :form, from_context: {Surface.Components.Form, :form} - The form identifier field :any, from_context: {Surface.Components.Form.Field, :field} - The field name id :string - The id of the corresponding select field name :string - The name of the corresponding select field class :css_class - The CSS class for the underlying tag options :any, default: [] - The options in the select prompt :string - An option to include at the top of the options with the given prompt text selected :any - The default value to use when none was sent as parameter opts :keyword, default: [] - Options list","ref":"Surface.Components.Form.Select.html","title":"Surface.Components.Form.Select","type":"module"},{"doc":"Callback implementation for Surface.Component.render/1 .","ref":"Surface.Components.Form.Select.html#render/1","title":"Surface.Components.Form.Select.render/1","type":"function"},{"doc":"Defines a submit button to send the form. All options are forwarded to the underlying &lt;button type=&quot;submit&quot; /&gt; Properties values :keyword, default: [] - List values that will be sent as part of the payload triggered by an event label :string - The label to be used in the button class :css_class - Class or classes to apply to the button opts :keyword, default: [] - Keyword list with options to be passed down to &lt;button/&gt; Slots default - Slot used for having children other than plain text in the button Events capture_click - Triggered when the component captures click click - Triggered when the component receives click window_focus - Triggered when the page receives focus window_blur - Triggered when the page loses focus focus - Triggered when the component receives focus blur - Triggered when the component loses focus window_keyup - Triggered when a key on the keyboard is released (window-level) window_keydown - Triggered when a key on the keyboard is pressed (window-level) keyup - Triggered when a key on the keyboard is released keydown - Triggered when a key on the keyboard is pressed","ref":"Surface.Components.Form.Submit.html","title":"Surface.Components.Form.Submit","type":"module"},{"doc":"Callback implementation for Surface.Component.render/1 .","ref":"Surface.Components.Form.Submit.html#render/1","title":"Surface.Components.Form.Submit.render/1","type":"function"},{"doc":"An input field that let the user enter a telephone number . Provides a wrapper for Phoenix.HTML.Form's telephone_input/3 function. All options passed via opts will be sent to telephone_input/3 , value , pattern and class can be set directly and will override anything in opts . Examples &lt; TelephoneInput form = &quot;user&quot; field = &quot;phone&quot; opts = { autofocus : &quot;autofocus&quot; } / &gt; Properties values :keyword, default: [] - List values that will be sent as part of the payload triggered by an event form :form, from_context: {Surface.Components.Form, :form} - An identifier for the form field :any, from_context: {Surface.Components.Form.Field, :field} - An identifier for the input id :string - The id of the corresponding input field name :string - The name of the corresponding input field value :string - Value to pre-populated the input class :css_class - Class or classes to apply to the input opts :keyword, default: [] - Options list pattern :string - A regular expression to validate the entered value Events capture_click - Triggered when the component captures click click - Triggered when the component receives click window_focus - Triggered when the page receives focus window_blur - Triggered when the page loses focus focus - Triggered when the component receives focus blur - Triggered when the component loses focus window_keyup - Triggered when a key on the keyboard is released (window-level) window_keydown - Triggered when a key on the keyboard is pressed (window-level) keyup - Triggered when a key on the keyboard is released keydown - Triggered when a key on the keyboard is pressed","ref":"Surface.Components.Form.TelephoneInput.html","title":"Surface.Components.Form.TelephoneInput","type":"module"},{"doc":"Callback implementation for Surface.Component.render/1 .","ref":"Surface.Components.Form.TelephoneInput.html#render/1","title":"Surface.Components.Form.TelephoneInput.render/1","type":"function"},{"doc":"An input field that let the user enter a multi-line text. Provides a wrapper for Phoenix.HTML.Form's textarea/3 function. All options passed via opts will be sent to textarea/3 . Explicitly defined properties like value and class can be set directly and will override anything in opts . Examples &lt; TextArea form = &quot;user&quot; field = &quot;summary&quot; cols = &quot;5&quot; rows = &quot;10&quot; opts = { autofocus : &quot;autofocus&quot; } / &gt; Properties values :keyword, default: [] - List values that will be sent as part of the payload triggered by an event form :form, from_context: {Surface.Components.Form, :form} - An identifier for the form field :any, from_context: {Surface.Components.Form.Field, :field} - An identifier for the input id :string - The id of the corresponding input field name :string - The name of the corresponding input field value :string - Value to pre-populated the input class :css_class - Class or classes to apply to the input opts :keyword, default: [] - Options list rows :string - Specifies the visible number of lines in a text area cols :string - Specifies the visible width of a text area Events capture_click - Triggered when the component captures click click - Triggered when the component receives click window_focus - Triggered when the page receives focus window_blur - Triggered when the page loses focus focus - Triggered when the component receives focus blur - Triggered when the component loses focus window_keyup - Triggered when a key on the keyboard is released (window-level) window_keydown - Triggered when a key on the keyboard is pressed (window-level) keyup - Triggered when a key on the keyboard is released keydown - Triggered when a key on the keyboard is pressed","ref":"Surface.Components.Form.TextArea.html","title":"Surface.Components.Form.TextArea","type":"module"},{"doc":"Callback implementation for Surface.Component.render/1 .","ref":"Surface.Components.Form.TextArea.html#render/1","title":"Surface.Components.Form.TextArea.render/1","type":"function"},{"doc":"An input field that let the user enter a single-line text . Provides a wrapper for Phoenix.HTML.Form's text_input/3 function. All options passed via opts will be sent to text_input/3 , value and class can be set directly and will override anything in opts . Examples &lt; TextInput form = &quot;user&quot; field = &quot;name&quot; opts = { autofocus : &quot;autofocus&quot; } / &gt; Properties values :keyword, default: [] - List values that will be sent as part of the payload triggered by an event form :form, from_context: {Surface.Components.Form, :form} - An identifier for the form field :any, from_context: {Surface.Components.Form.Field, :field} - An identifier for the input id :string - The id of the corresponding input field name :string - The name of the corresponding input field value :string - Value to pre-populated the input class :css_class - Class or classes to apply to the input opts :keyword, default: [] - Options list Events capture_click - Triggered when the component captures click click - Triggered when the component receives click window_focus - Triggered when the page receives focus window_blur - Triggered when the page loses focus focus - Triggered when the component receives focus blur - Triggered when the component loses focus window_keyup - Triggered when a key on the keyboard is released (window-level) window_keydown - Triggered when a key on the keyboard is pressed (window-level) keyup - Triggered when a key on the keyboard is released keydown - Triggered when a key on the keyboard is pressed","ref":"Surface.Components.Form.TextInput.html","title":"Surface.Components.Form.TextInput","type":"module"},{"doc":"Callback implementation for Surface.Component.render/1 .","ref":"Surface.Components.Form.TextInput.html#render/1","title":"Surface.Components.Form.TextInput.render/1","type":"function"},{"doc":"An input field that let the user enter a time (hours, minutes and optionally seconds). Provides a wrapper for Phoenix.HTML.Form's time_input/3 function. All options passed via opts will be sent to time_input/3 , value and class can be set directly and will override anything in opts . Examples &lt; TimeInput form = &quot;user&quot; field = &quot;name&quot; opts = { autofocus : &quot;autofocus&quot; } / &gt; Properties values :keyword, default: [] - List values that will be sent as part of the payload triggered by an event form :form, from_context: {Surface.Components.Form, :form} - An identifier for the form field :any, from_context: {Surface.Components.Form.Field, :field} - An identifier for the input id :string - The id of the corresponding input field name :string - The name of the corresponding input field value :string - Value to pre-populated the input class :css_class - Class or classes to apply to the input opts :keyword, default: [] - Options list Events capture_click - Triggered when the component captures click click - Triggered when the component receives click window_focus - Triggered when the page receives focus window_blur - Triggered when the page loses focus focus - Triggered when the component receives focus blur - Triggered when the component loses focus window_keyup - Triggered when a key on the keyboard is released (window-level) window_keydown - Triggered when a key on the keyboard is pressed (window-level) keyup - Triggered when a key on the keyboard is released keydown - Triggered when a key on the keyboard is pressed","ref":"Surface.Components.Form.TimeInput.html","title":"Surface.Components.Form.TimeInput","type":"module"},{"doc":"Callback implementation for Surface.Component.render/1 .","ref":"Surface.Components.Form.TimeInput.html#render/1","title":"Surface.Components.Form.TimeInput.render/1","type":"function"},{"doc":"Generates select tags for time. Provides a wrapper for Phoenix.HTML.Form's time_select/3 function. All options passed via opts will be sent to time_select/3 , value , default , hour , minute , second and builder can be set directly and will override anything in opts . Examples &lt; TimeSelect form = &quot;alarm&quot; field = &quot;time&quot; / &gt; &lt; Form for = { :alarm } &gt; &lt; TimeSelect field = { :time } / &gt; &lt; / Form &gt; Properties form :form, from_context: {Surface.Components.Form, :form} - The form identifier field :any, from_context: {Surface.Components.Form.Field, :field} - The field name id :string - The id prefix for underlying select fields name :string - The name prefix for underlying select fields value :any - Value to pre-populate the select default :any - Default value to use when none was given in 'value' and none is available in the form data hour :keyword - Options passed to the underlying 'day' select minute :keyword - Options passed to the underlying 'day' select second :keyword - Options passed to the underlying 'day' select builder :fun - Specify how the select can be build. It must be a function that receives a builder that should be invoked with the select name and a set of options. opts :keyword, default: [] - Options list","ref":"Surface.Components.Form.TimeSelect.html","title":"Surface.Components.Form.TimeSelect","type":"module"},{"doc":"Callback implementation for Surface.Component.render/1 .","ref":"Surface.Components.Form.TimeSelect.html#render/1","title":"Surface.Components.Form.TimeSelect.render/1","type":"function"},{"doc":"An input field that let the user enter a URL . Provides a wrapper for Phoenix.HTML.Form's url_input/3 function. All options passed via opts will be sent to url_input/3 , value and class can be set directly and will override anything in opts . Examples &lt; UrlInput form = &quot;user&quot; field = &quot;name&quot; opts = { autofocus : &quot;autofocus&quot; } / &gt; Properties values :keyword, default: [] - List values that will be sent as part of the payload triggered by an event form :form, from_context: {Surface.Components.Form, :form} - An identifier for the form field :any, from_context: {Surface.Components.Form.Field, :field} - An identifier for the input id :string - The id of the corresponding input field name :string - The name of the corresponding input field value :string - Value to pre-populated the input class :css_class - Class or classes to apply to the input opts :keyword, default: [] - Options list Events capture_click - Triggered when the component captures click click - Triggered when the component receives click window_focus - Triggered when the page receives focus window_blur - Triggered when the page loses focus focus - Triggered when the component receives focus blur - Triggered when the component loses focus window_keyup - Triggered when a key on the keyboard is released (window-level) window_keydown - Triggered when a key on the keyboard is pressed (window-level) keyup - Triggered when a key on the keyboard is released keydown - Triggered when a key on the keyboard is pressed","ref":"Surface.Components.Form.UrlInput.html","title":"Surface.Components.Form.UrlInput","type":"module"},{"doc":"Callback implementation for Surface.Component.render/1 .","ref":"Surface.Components.Form.UrlInput.html#render/1","title":"Surface.Components.Form.UrlInput.render/1","type":"function"},{"doc":"A behaviour to provide additional information about the catalogue. Optional for local catalogues. Usually required if you want to share your components as a library.","ref":"Surface.Catalogue.html","title":"Surface.Catalogue","type":"behaviour"},{"doc":"Returns a keyword list of config options to be used by the catalogue tool. Available options: head_css - CSS related content to be added to the &lt;head&gt;...&lt;/head&gt; section of each example or playground. head_js - JS related content to be added to the &lt;head&gt;...&lt;/head&gt; section of each example or playground. example - A keyword list of options to be applied for all examples in the catalogue. playground - A keyword list of options to be applied for all playgrounds in the catalogue.","ref":"Surface.Catalogue.html#c:config/0","title":"Surface.Catalogue.config/0","type":"callback"},{"doc":"Loads a text file as module attribute so you can inject its content directly in head_css or head_js config options. Useful to avoid depending on external css or js code. The path should be relative to the caller's folder. Available options: as - the name of the module attribute to be generated.","ref":"Surface.Catalogue.html#load_asset/2","title":"Surface.Catalogue.load_asset/2","type":"macro"},{"doc":"Experimental module that provides conveniences for manipulating data in Examples and Playgrounds. Provide wrappers around built-in functions like get_in/2 and update_in/3 using a shorter syntax for accessors. Accessor Mapping [_] : Access.all/0 [fun] : Access.filter(fun) [index] : Access.at(index) (Shorthand for [index: i] ) [index: i] : Access.at(i) [key: k] : Access.key(k) [first..last] : Surface.Catalogue.Data.slice(first..last) Example Data . get ( props . lists [ _ ] . cards [ &amp; &amp;1 . id == &quot;Card_1&quot; ] . tags [ - 1 ] . name ) The code above will be translated to: get_in ( props , [ :lists , Access . all , :cards , Access . filter ( &amp; &amp;1 . id == &quot;Card_1&quot; ) , :tags , Access . at ( - 1 ) , :name ] )","ref":"Surface.Catalogue.Data.html","title":"Surface.Catalogue.Data","type":"module"},{"doc":"Appends an item to a list in the given nested structure.","ref":"Surface.Catalogue.Data.html#append/2","title":"Surface.Catalogue.Data.append/2","type":"macro"},{"doc":"Deletes an item from the given nested structure.","ref":"Surface.Catalogue.Data.html#delete/1","title":"Surface.Catalogue.Data.delete/1","type":"macro"},{"doc":"Gets an existing value from the given nested structure. Raises an error if none or more than one value is found.","ref":"Surface.Catalogue.Data.html#get!/1","title":"Surface.Catalogue.Data.get!/1","type":"macro"},{"doc":"Gets a value from the given nested structure. A wrapper around get_in/2","ref":"Surface.Catalogue.Data.html#get/1","title":"Surface.Catalogue.Data.get/1","type":"macro"},{"doc":"Gets a value and updates a given nested structure. A wrapper around get_and_update_in/3","ref":"Surface.Catalogue.Data.html#get_and_update/2","title":"Surface.Catalogue.Data.get_and_update/2","type":"macro"},{"doc":"Inserts an item into a list in the given nested structure.","ref":"Surface.Catalogue.Data.html#insert_at/3","title":"Surface.Catalogue.Data.insert_at/3","type":"macro"},{"doc":"Pops a item from the given nested structure. A wrapper around pop_in/2","ref":"Surface.Catalogue.Data.html#pop/1","title":"Surface.Catalogue.Data.pop/1","type":"macro"},{"doc":"Prepends an item to a list in the given nested structure.","ref":"Surface.Catalogue.Data.html#prepend/2","title":"Surface.Catalogue.Data.prepend/2","type":"macro"},{"doc":"Generates a short ramdom id.","ref":"Surface.Catalogue.Data.html#random_id/1","title":"Surface.Catalogue.Data.random_id/1","type":"function"},{"doc":"","ref":"Surface.Catalogue.Data.html#slice/1","title":"Surface.Catalogue.Data.slice/1","type":"function"},{"doc":"","ref":"Surface.Catalogue.Data.html#unnest/1","title":"Surface.Catalogue.Data.unnest/1","type":"function"},{"doc":"Updates an item in the given nested structure. A wrapper around update_in/2","ref":"Surface.Catalogue.Data.html#update/2","title":"Surface.Catalogue.Data.update/2","type":"macro"},{"doc":"A generic LiveView to create a single example for catalogue tools. Options Besides the buit-in options provided by the LiveView itself, an Example also provides the following options: subject - Required. The target component of the Example. height - Required. The height of the Example. catalogue - Optional. A module that implements the Surface.Catalogue providing additional information to the catalogue tool. Usually required if you want to share your components as a library. body - Optional. Sets/overrides the attributes of the the Example's body tag. Useful to set a different background or padding. title - Optional. The title of the example. direction - Optional. Defines how the example + code boxes should be displayed. Available values are &quot;horizontal&quot; or &quot;vertical&quot;. Default is &quot;horizontal&quot; (side-by-side). code_perc - Optional. When the direction is &quot;horizontal&quot;, defines the percentage of the total width that the code box should take. Default is 50 . Note: This configuration has no effect when direction is &quot;vertical&quot;. assert - Optional. When using catalogue_test/1 , generates simple =~ assertions for the given text or list of texts.","ref":"Surface.Catalogue.Example.html","title":"Surface.Catalogue.Example","type":"module"},{"doc":"A generic LiveView to create multiple examples for catalogue tools. Each example must be a function component defined with the module attribute @example . Options Besides the buit-in options provided by the LiveView itself, examples can also pass the following options at the module level: subject - Required. The target component of the Example. catalogue - Optional. A module that implements the Surface.Catalogue providing additional information to the catalogue tool. Usually required if you want to share your components as a library. Other options can be defined at the module level but also overridden at the function/example level using the @example module attribute. They are: height - Required (either for the module or function). The height of the Example. title - Optional. The title of the example. body - Optional. Sets/overrides the attributes of the the Example's body tag. Useful to set a different background or padding. direction - Optional. Defines how the example + code boxes should be displayed. Available values are &quot;horizontal&quot; or &quot;vertical&quot;. Default is &quot;horizontal&quot; (side-by-side). code_perc - Optional. When the direction is &quot;horizontal&quot;, defines the percentage of the total width that the code box should take. Default is 50 . Note: This configuration has no effect when direction is &quot;vertical&quot;. assert - Optional. When using catalogue_test/1 , generates simple =~ assertions for the given text or list of texts. This option is available only for Examples, not Playgrounds. When defined at the module level, i.e. passing to use Surface.Catalogue.Example, ... , the options apply to all examples. Aside from subject and catalogue , options can be overridden at the function level using the @example module attribute. Examples Basic usage @example true def basic_example ( assigns ) do ~F&quot;&quot;&quot; &lt;Button&gt;OK&lt;/Button&gt; &quot;&quot;&quot; end Defining a custom title + docs @example &quot;Example with docs&quot; @doc &quot;A simple example with documentation&quot; def example_01 ( assigns ) do ~F&quot;&quot;&quot; &lt;Button&gt;OK&lt;/Button&gt; &quot;&quot;&quot; end Defining other options @example [ title : &quot;Example and Code split vertically&quot; , direction : &quot;vertical&quot; , height : &quot;110px&quot; , assert : [ &quot;Small&quot; , &quot;Medium&quot; , &quot;Large&quot; ] ] def vertical ( assigns ) do ~F&quot;&quot;&quot; &lt;Button size=&quot;small&quot; color=&quot;info&quot;&gt;Small&lt;/Button&gt; &lt;Button size=&quot;medium&quot; color=&quot;warning&quot;&gt;Medium&lt;/Button&gt; &lt;Button size=&quot;large&quot; color=&quot;danger&quot;&gt;Large&lt;/Button&gt; &quot;&quot;&quot; end Notice that whenever you want to pass other options using a keyword list as in the example above, in case you need to customize the title, it must to be passed as a key/value option as well.","ref":"Surface.Catalogue.Examples.html","title":"Surface.Catalogue.Examples","type":"module"},{"doc":"A generic LiveView to create a component's playground for the Surface Catalogue. Options Besides the buit-in options provided by the LiveView itself, a Playground also provides the following options: subject - Required. The target component of the Playground. height - Required. The initial height of the Playground. catalogue - Optional. A module that implements the Surface.Catalogue providing additional information to the catalogue tool. Usually required if you want to share your components as a library. body - Optional. Sets/overrides the attributes of the Playground's body tag. Useful to set a different background or padding. Initializing props and slots If you need to define initial values for props or slots of the component, you can use the @props and @slots module attributes, respectively. Both attributes are optional and take a keyword list containing all the props/slots you need to initialize. Pay attention that if you have required props/slots, you should provide initial values for them. Example defmodule MyApp.Components.MyButton.Playground do use Surface.Catalogue.Playground , subject : MyApp.Components.MyButton , height : &quot;170px&quot; @props [ class : &quot;btn&quot; ] @slots [ default : &quot;Cancel&quot; ] end","ref":"Surface.Catalogue.Playground.html","title":"Surface.Catalogue.Playground","type":"module"},{"doc":"Defines a behaviour that must be implemented by all HTML/Surface node translators. This module also contains the main logic to translate Surface code.","ref":"Surface.Compiler.html","title":"Surface.Compiler","type":"module"},{"doc":"This function compiles a string into the Surface AST.This is used by ~F and Surface.Renderer to parse and compile templates. A special note for line: This is considered the line number for the first line in the string. If the first line of the string is also the first line of the file, then this should be 1. If this is being called within a macro (say to process a heredoc passed to ~F), this should be CALLER .line + 1.","ref":"Surface.Compiler.html#compile/5","title":"Surface.Compiler.compile/5","type":"function"},{"doc":"","ref":"Surface.Compiler.html#to_ast/2","title":"Surface.Compiler.to_ast/2","type":"function"},{"doc":"","ref":"Surface.Compiler.html#to_live_struct/2","title":"Surface.Compiler.to_live_struct/2","type":"function"},{"doc":"","ref":"Surface.Compiler.html#validate_component_structure/3","title":"Surface.Compiler.validate_component_structure/3","type":"function"},{"doc":"","ref":"Surface.Compiler.CSSParserError.html","title":"Surface.Compiler.CSSParserError","type":"exception"},{"doc":"","ref":"Surface.Compiler.CallerSpec.html","title":"Surface.Compiler.CallerSpec","type":"module"},{"doc":"","ref":"Surface.Compiler.CallerSpec.html#t:t/0","title":"Surface.Compiler.CallerSpec.t/0","type":"type"},{"doc":"","ref":"Surface.Compiler.CompileMeta.html","title":"Surface.Compiler.CompileMeta","type":"module"},{"doc":"","ref":"Surface.Compiler.CompileMeta.html#t:t/0","title":"Surface.Compiler.CompileMeta.t/0","type":"type"},{"doc":"This module glues together surface's AST and Phoenix.LiveView.Engine to actually render an AST. It takes a list of Surface AST nodes, and processes them into a sequence of static raw html items and dynamic pieces. It then converts these into tokens which an EEx engine can understand (see EEx.Tokenizer for information on this). Finally, it passes these tokens into the engine sequentially in the same manner as EEx.Compiler.compile/2","ref":"Surface.Compiler.EExEngine.html","title":"Surface.Compiler.EExEngine","type":"module"},{"doc":"","ref":"Surface.Compiler.EExEngine.html#translate/2","title":"Surface.Compiler.EExEngine.translate/2","type":"function"},{"doc":"","ref":"Surface.Compiler.ParseError.html","title":"Surface.Compiler.ParseError","type":"exception"},{"doc":"","ref":"Surface.Directive.html","title":"Surface.Directive","type":"behaviour"},{"doc":"","ref":"Surface.Directive.html#c:extract/2","title":"Surface.Directive.extract/2","type":"callback"},{"doc":"","ref":"Surface.Directive.html#c:process/2","title":"Surface.Directive.process/2","type":"callback"},{"doc":"","ref":"Surface.Directive.ComponentProps.html","title":"Surface.Directive.ComponentProps","type":"module"},{"doc":"Callback implementation for Surface.Directive.extract/2 .","ref":"Surface.Directive.ComponentProps.html#extract/2","title":"Surface.Directive.ComponentProps.extract/2","type":"function"},{"doc":"Callback implementation for Surface.Directive.process/2 .","ref":"Surface.Directive.ComponentProps.html#process/2","title":"Surface.Directive.ComponentProps.process/2","type":"function"},{"doc":"","ref":"Surface.Directive.Debug.html","title":"Surface.Directive.Debug","type":"module"},{"doc":"Callback implementation for Surface.Directive.extract/2 .","ref":"Surface.Directive.Debug.html#extract/2","title":"Surface.Directive.Debug.extract/2","type":"function"},{"doc":"Callback implementation for Surface.Directive.process/2 .","ref":"Surface.Directive.Debug.html#process/2","title":"Surface.Directive.Debug.process/2","type":"function"},{"doc":"","ref":"Surface.Directive.Events.html","title":"Surface.Directive.Events","type":"module"},{"doc":"Callback implementation for Surface.Directive.extract/2 .","ref":"Surface.Directive.Events.html#extract/2","title":"Surface.Directive.Events.extract/2","type":"function"},{"doc":"","ref":"Surface.Directive.Events.html#phx_events/0","title":"Surface.Directive.Events.phx_events/0","type":"function"},{"doc":"Callback implementation for Surface.Directive.process/2 .","ref":"Surface.Directive.Events.html#process/2","title":"Surface.Directive.Events.process/2","type":"function"},{"doc":"","ref":"Surface.Directive.For.html","title":"Surface.Directive.For","type":"module"},{"doc":"Callback implementation for Surface.Directive.extract/2 .","ref":"Surface.Directive.For.html#extract/2","title":"Surface.Directive.For.extract/2","type":"function"},{"doc":"Callback implementation for Surface.Directive.process/2 .","ref":"Surface.Directive.For.html#process/2","title":"Surface.Directive.For.process/2","type":"function"},{"doc":"","ref":"Surface.Directive.Hook.html","title":"Surface.Directive.Hook","type":"module"},{"doc":"Callback implementation for Surface.Directive.extract/2 .","ref":"Surface.Directive.Hook.html#extract/2","title":"Surface.Directive.Hook.extract/2","type":"function"},{"doc":"Callback implementation for Surface.Directive.process/2 .","ref":"Surface.Directive.Hook.html#process/2","title":"Surface.Directive.Hook.process/2","type":"function"},{"doc":"","ref":"Surface.Directive.If.html","title":"Surface.Directive.If","type":"module"},{"doc":"Callback implementation for Surface.Directive.extract/2 .","ref":"Surface.Directive.If.html#extract/2","title":"Surface.Directive.If.extract/2","type":"function"},{"doc":"Callback implementation for Surface.Directive.process/2 .","ref":"Surface.Directive.If.html#process/2","title":"Surface.Directive.If.process/2","type":"function"},{"doc":"","ref":"Surface.Directive.Let.html","title":"Surface.Directive.Let","type":"module"},{"doc":"Callback implementation for Surface.Directive.extract/2 .","ref":"Surface.Directive.Let.html#extract/2","title":"Surface.Directive.Let.extract/2","type":"function"},{"doc":"Callback implementation for Surface.Directive.process/2 .","ref":"Surface.Directive.Let.html#process/2","title":"Surface.Directive.Let.process/2","type":"function"},{"doc":"","ref":"Surface.Directive.Show.html","title":"Surface.Directive.Show","type":"module"},{"doc":"Callback implementation for Surface.Directive.extract/2 .","ref":"Surface.Directive.Show.html#extract/2","title":"Surface.Directive.Show.extract/2","type":"function"},{"doc":"Callback implementation for Surface.Directive.process/2 .","ref":"Surface.Directive.Show.html#process/2","title":"Surface.Directive.Show.process/2","type":"function"},{"doc":"","ref":"Surface.Directive.TagAttrs.html","title":"Surface.Directive.TagAttrs","type":"module"},{"doc":"Callback implementation for Surface.Directive.extract/2 .","ref":"Surface.Directive.TagAttrs.html#extract/2","title":"Surface.Directive.TagAttrs.extract/2","type":"function"},{"doc":"Callback implementation for Surface.Directive.process/2 .","ref":"Surface.Directive.TagAttrs.html#process/2","title":"Surface.Directive.TagAttrs.process/2","type":"function"},{"doc":"","ref":"Surface.Directive.Values.html","title":"Surface.Directive.Values","type":"module"},{"doc":"Callback implementation for Surface.Directive.extract/2 .","ref":"Surface.Directive.Values.html#extract/2","title":"Surface.Directive.Values.extract/2","type":"function"},{"doc":"Callback implementation for Surface.Directive.process/2 .","ref":"Surface.Directive.Values.html#process/2","title":"Surface.Directive.Values.process/2","type":"function"},{"doc":"","ref":"Surface.Directive.Values.html#validate_value!/2","title":"Surface.Directive.Values.validate_value!/2","type":"function"},{"doc":"","ref":"Surface.AST.html","title":"Surface.AST","type":"module"},{"doc":"","ref":"Surface.AST.html#find_attribute_value/2","title":"Surface.AST.find_attribute_value/2","type":"function"},{"doc":"","ref":"Surface.AST.html#has_attribute?/2","title":"Surface.AST.has_attribute?/2","type":"function"},{"doc":"","ref":"Surface.AST.html#pop_attributes_as_map/2","title":"Surface.AST.pop_attributes_as_map/2","type":"function"},{"doc":"","ref":"Surface.AST.html#pop_attributes_values_as_map/2","title":"Surface.AST.pop_attributes_values_as_map/2","type":"function"},{"doc":"","ref":"Surface.AST.html#t:t/0","title":"Surface.AST.t/0","type":"type"},{"doc":"An AST node representing an attribute or property Properties * ` :type ` - an atom representing the type of attribute . See Surface.API for the list of supported types * ` :type_opts ` - a keyword list of options for the type * ` :name ` - the name of the attribute ( e . g . ` :class ` ) * ` :root ` - true if the attribute was defined using root notation ` { ... } ` . Root attributes won &#39; t have ` name ` . * ` :value ` - a list of nodes that can be concatenated to form the value for this attribute . Potentially contains dynamic data * ` :meta ` - compilation meta data","ref":"Surface.AST.Attribute.html","title":"Surface.AST.Attribute","type":"module"},{"doc":"","ref":"Surface.AST.Attribute.html#t:t/0","title":"Surface.AST.Attribute.t/0","type":"type"},{"doc":"An AST node representing an attribute expression (i.e. a dynamic value for an attribute, directive, or property) Properties * ` :original ` - the original text , useful for debugging and error messages * ` :value ` - a quoted expression * ` :constant? ` - true if the expression can be evaluated at compile time * ` :meta ` - compilation meta data","ref":"Surface.AST.AttributeExpr.html","title":"Surface.AST.AttributeExpr","type":"module"},{"doc":"","ref":"Surface.AST.AttributeExpr.html#new/3","title":"Surface.AST.AttributeExpr.new/3","type":"function"},{"doc":"","ref":"Surface.AST.AttributeExpr.html#t:t/0","title":"Surface.AST.AttributeExpr.t/0","type":"type"},{"doc":"An AST node representing a generic block. Properties * ` :name ` - name of the block * ` :expression ` - the expression passed to block * ` :sub_blocks ` - a list containing each sub - block &#39; s { name , children_ast } * ` :meta ` - compile meta * ` :debug ` - keyword list indicating when debug information should be printed during compilation","ref":"Surface.AST.Block.html","title":"Surface.AST.Block","type":"module"},{"doc":"","ref":"Surface.AST.Block.html#t:t/0","title":"Surface.AST.Block.t/0","type":"type"},{"doc":"An AST node representing a component Properties * ` :module ` - the component module * ` :type ` - the type of component ( i . e . Surface.LiveComponent vs Surface.LiveView or :dynamic_live ) * ` :props ` - the props for this component * ` :directives ` - any directives to be applied to this tag * ` :children ` - the tag children * ` :meta ` - compilation meta data * ` :debug ` - keyword list indicating when debug information should be printed during compilation","ref":"Surface.AST.Component.html","title":"Surface.AST.Component","type":"module"},{"doc":"","ref":"Surface.AST.Component.html#t:t/0","title":"Surface.AST.Component.t/0","type":"type"},{"doc":"An AST node representing a container of other nodes. This does not have content itself, just contains children which have content, and directives that operate on the entirety of the children (i.e. for, if, debug) Properties * ` :children ` - children AST nodes * ` :attributes ` - the specified attributes * ` :directives ` - directives associated with this container * ` :meta ` - compile meta * ` :debug ` - keyword list indicating when debug information should be printed during compilation","ref":"Surface.AST.Container.html","title":"Surface.AST.Container","type":"module"},{"doc":"","ref":"Surface.AST.Container.html#t:t/0","title":"Surface.AST.Container.t/0","type":"type"},{"doc":"An AST node representing a directive Properties * ` :module ` - the module which implements logic for this directive ( e . g . ` Surface.Directive.Let ` ) * ` :name ` - the name of the directive ( e . g . ` :let ` ) * ` :value ` - the code / configuration for this directive . typically a quoted expression * ` :meta ` - compilation meta data","ref":"Surface.AST.Directive.html","title":"Surface.AST.Directive","type":"module"},{"doc":"","ref":"Surface.AST.Directive.html#t:t/0","title":"Surface.AST.Directive.t/0","type":"type"},{"doc":"An AST node representing a dynamic attribute (or attributes). Properties * ` :expr ` - an expression which will generate a keyword list of attributes and value tuples of the form { type , value } * ` :meta ` - compilation meta data","ref":"Surface.AST.DynamicAttribute.html","title":"Surface.AST.DynamicAttribute","type":"module"},{"doc":"","ref":"Surface.AST.DynamicAttribute.html#t:t/0","title":"Surface.AST.DynamicAttribute.t/0","type":"type"},{"doc":"An AST node representing an error. This will be rendered as an html element. Properties * ` :message ` - the error message * ` :meta ` - compilation meta data * ` :attributes ` - the specified attributes * ` :directives ` - directives associated with this error node","ref":"Surface.AST.Error.html","title":"Surface.AST.Error","type":"module"},{"doc":"","ref":"Surface.AST.Error.html#t:t/0","title":"Surface.AST.Error.t/0","type":"type"},{"doc":"An AST node representing an expression which does not resolve to a value printed out to the final DOM. Properties * ` :value ` - a quoted expression * ` :constant? ` - true if the expression can be evaluated at compile time * ` :meta ` - compile meta * ` :directives ` - directives associated with this expression node","ref":"Surface.AST.Expr.html","title":"Surface.AST.Expr","type":"module"},{"doc":"","ref":"Surface.AST.Expr.html#t:t/0","title":"Surface.AST.Expr.t/0","type":"type"},{"doc":"An AST node representing a for comprehension. Properties * ` :generator ` - a quoted expression * ` :children ` - the children to collect over the generator * ` :meta ` - compilation meta data * ` :debug ` - keyword list indicating when debug information should be printed during compilation * ` :directives ` - directives associated with this node","ref":"Surface.AST.For.html","title":"Surface.AST.For","type":"module"},{"doc":"","ref":"Surface.AST.For.html#t:t/0","title":"Surface.AST.For.t/0","type":"type"},{"doc":"An AST node representing a function component Properties * ` :module ` - the component module * ` :fun ` - the render function * ` :type ` - the type of function ( :local or :remote ) * ` :props ` - the props for this component * ` :directives ` - any directives to be applied to this tag * ` :children ` - the tag children * ` :meta ` - compilation meta data * ` :debug ` - keyword list indicating when debug information should be printed during compilation","ref":"Surface.AST.FunctionComponent.html","title":"Surface.AST.FunctionComponent","type":"module"},{"doc":"","ref":"Surface.AST.FunctionComponent.html#t:t/0","title":"Surface.AST.FunctionComponent.t/0","type":"type"},{"doc":"An AST node representing an if/else expression Properties * ` :condition ` - a quoted expression * ` :children ` - the children to insert into the dom if the condition evaluates truthy * ` :else ` - the children to insert into the dom if the condition evaluates falsy * ` :meta ` - compilation meta data * ` :debug ` - keyword list indicating when debug information should be printed during compilation * ` :directives ` - directives associated with this node","ref":"Surface.AST.If.html","title":"Surface.AST.If","type":"module"},{"doc":"","ref":"Surface.AST.If.html#t:t/0","title":"Surface.AST.If.t/0","type":"type"},{"doc":"An AST node representing interpolation within a node Properties * ` :original ` - the original text , useful for debugging and error messages * ` :value ` - a quoted expression * ` :constant? ` - true if the expression can be evaluated at compile time * ` :meta ` - compilation meta data * ` :directives ` - directives associated with this interpolation","ref":"Surface.AST.Interpolation.html","title":"Surface.AST.Interpolation","type":"module"},{"doc":"","ref":"Surface.AST.Interpolation.html#t:t/0","title":"Surface.AST.Interpolation.t/0","type":"type"},{"doc":"An AST node representing a literal value Properties * ` :value ` - the value * ` :directives ` - directives associated with this literal value","ref":"Surface.AST.Literal.html","title":"Surface.AST.Literal","type":"module"},{"doc":"","ref":"Surface.AST.Literal.html#t:t/0","title":"Surface.AST.Literal.t/0","type":"type"},{"doc":"An AST node representing a macro component Properties * ` :module ` - the component module * ` :attributes ` - the specified attributes * ` :directives ` - any directives to be applied to this macro * ` :children ` - the children after the macro is expanded * ` :meta ` - compilation meta data * ` :debug ` - keyword list indicating when debug information should be printed during compilation","ref":"Surface.AST.MacroComponent.html","title":"Surface.AST.MacroComponent","type":"module"},{"doc":"","ref":"Surface.AST.MacroComponent.html#t:t/0","title":"Surface.AST.MacroComponent.t/0","type":"type"},{"doc":"A container for metadata about compilation. Properties * ` :line ` - the line from the source code where the parent was extracted * ` :module ` - the component module ( e . g . ` Surface.Components.LivePatch ` ) * ` :node_alias ` - the alias used inside the source code ( e . g . ` LivePatch ` ) * ` :file ` - the file from which the source was extracted * ` :caller ` - a Macro.Env struct representing the caller * ` :function_component? ` - indicates if it &#39; s a function component or not * ` :style ` - the style info of the component , if any","ref":"Surface.AST.Meta.html","title":"Surface.AST.Meta","type":"module"},{"doc":"","ref":"Surface.AST.Meta.html#t:t/0","title":"Surface.AST.Meta.t/0","type":"type"},{"doc":"An AST node representing a &lt;#slot /&gt; tag Properties * ` :name ` - the slot name * ` :index ` - the index of the slotable entry assigned to this slot * ` :for ` - the slotable entry assigned for this slot * ` :default ` - a list of AST nodes representing the default content for this slot * ` :arg ` - quoted expression representing the argument for this slot * ` :generator_value ` - value from the ` :generator_prop ` property * ` :context_put ` - value from the ` :generator_prop ` property * ` :meta ` - compilation meta data * ` :directives ` - directives associated with this slot","ref":"Surface.AST.Slot.html","title":"Surface.AST.Slot","type":"module"},{"doc":"","ref":"Surface.AST.Slot.html#t:t/0","title":"Surface.AST.Slot.t/0","type":"type"},{"doc":"An AST node representing a &lt;:slot&gt; entry. This is used to provide content for slots Properties * ` :name ` - the slot entry name * ` :props ` - the props for slot entry tag * ` :let ` - the ` :let ` expression * ` :children ` - the slot entry children * ` :meta ` - compilation meta data * ` :debug ` - keyword list indicating when debug information should be printed during compilation * ` :directives ` - directives associated with this slot entry","ref":"Surface.AST.SlotEntry.html","title":"Surface.AST.SlotEntry","type":"module"},{"doc":"","ref":"Surface.AST.SlotEntry.html#t:t/0","title":"Surface.AST.SlotEntry.t/0","type":"type"},{"doc":"An AST node representing a standard HTML tag Properties * ` :module ` - the component module * ` :type ` - the type of component ( i . e . Surface.LiveComponent vs Surface.Component ) * ` :slot ` - the name of the slot that this component is for * ` :let ` - the ` :let ` expression * ` :props ` - the props for this component * ` :directives ` - any directives to be applied to this tag * ` :children ` - the tag children * ` :meta ` - compilation meta data * ` :debug ` - keyword list indicating when debug information should be printed during compilation","ref":"Surface.AST.SlotableComponent.html","title":"Surface.AST.SlotableComponent","type":"module"},{"doc":"","ref":"Surface.AST.SlotableComponent.html#t:t/0","title":"Surface.AST.SlotableComponent.t/0","type":"type"},{"doc":"An AST node representing a generic sub-block. Properties * ` :name ` - name of the block * ` :expression ` - the expression passed to block * ` :children ` - children AST nodes * ` :meta ` - compile meta * ` :debug ` - keyword list indicating when debug information should be printed during compilation","ref":"Surface.AST.SubBlock.html","title":"Surface.AST.SubBlock","type":"module"},{"doc":"","ref":"Surface.AST.SubBlock.html#t:t/0","title":"Surface.AST.SubBlock.t/0","type":"type"},{"doc":"An AST node representing a standard HTML tag Properties * ` :element ` - the element name * ` :attributes ` - the attributes for this tag * ` :directives ` - any directives to be applied to this tag * ` :children ` - the tag children * ` :meta ` - compilation meta data * ` :debug ` - keyword list indicating when debug information should be printed during compilation","ref":"Surface.AST.Tag.html","title":"Surface.AST.Tag","type":"module"},{"doc":"","ref":"Surface.AST.Tag.html#t:t/0","title":"Surface.AST.Tag.t/0","type":"type"},{"doc":"An AST node representing a void (empty) HTML tag Properties * ` :element ` - the element name * ` :attributes ` - the attributes for this tag * ` :directives ` - any directives to be applied to this tag * ` :meta ` - compilation meta data * ` :debug ` - keyword list indicating when debug information should be printed during compilation","ref":"Surface.AST.VoidTag.html","title":"Surface.AST.VoidTag","type":"module"},{"doc":"","ref":"Surface.AST.VoidTag.html#t:t/0","title":"Surface.AST.VoidTag.t/0","type":"type"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Fix error when trying to add the caller's scope_id attr to a MacroComponent","ref":"changelog.html#v0-9-3-2023-02-09","title":"Changelog - v0.9.3 (2023-02-09)","type":"extras"},{"doc":"Compatibility with Liveview &gt;= v0.18.5 Optimize static props for diff tracking Fix child components' root DOM element not belonging to the parent's scope (#670) Fix missing shortdoc on surface.init prevents task discovery from mix help (#666)","ref":"changelog.html#v0-9-2-2023-02-06","title":"Changelog - v0.9.2 (2023-02-06)","type":"extras"},{"doc":"Fix dialyzer errors","ref":"changelog.html#v0-9-1-2022-09-26","title":"Changelog - v0.9.1 (2022-09-26)","type":"extras"},{"doc":"Support Liveview v0.18","ref":"changelog.html#v0-9-0-2022-09-23","title":"Changelog - v0.9.0 (2022-09-23)","type":"extras"},{"doc":"Fix dialyzer errors","ref":"changelog.html#v0-8-4-2022-09-26","title":"Changelog - v0.8.4 (2022-09-26)","type":"extras"},{"doc":"Add :global pseudo-class to the Scoped CSS's API Declare props container , session and sticky on Surface.LiveView Fix CSS tokenizer not handling empty strings Fix CSS parser for declarations with commas or variants Fix scoped styles on void elements Fix dialyzer issue in EExEngine (#655)","ref":"changelog.html#v0-8-3-2022-09-22","title":"Changelog - v0.8.3 (2022-09-22)","type":"extras"},{"doc":"Remove compile-time deps from components, avoiding unnecessary recompilation of extra files due to transitive deps (#653) Fix components oversized beam files (#651) Fix error on layout templates containing &lt;style&gt;","ref":"changelog.html#v0-8-2-2022-09-16","title":"Changelog - v0.8.2 (2022-09-16)","type":"extras"},{"doc":"Fix surface compiler when setting a different css_output_file (#646) Fix formatter for :debug","ref":"changelog.html#v0-8-1-2022-09-02","title":"Changelog - v0.8.1 (2022-09-02)","type":"extras"},{"doc":"Support scoped CSS styles for components using either inline &lt;style&gt; tags or colocated .css files (#621) Add render_sface/1 to allow overriding render/1 and compute/update assigns when using external .sface files Add --tailwind option to mix surface.init to bootstrap a project with TailwindCSS support Add --layouts option to mix surface.init to replace .heex layout files with corresponding .sface files Add --web-module option to mix surface.init to override the default web module (#638) Support using the :hook directive to point to the default hook exported in the .hooks.js file Add option from_context to prop and data to allow setting values directly from the context Add Context.put/3 and Context.get/2 to allow manipulating the context inside lifecycle callbacks and render/1 Add prop context_put to &lt;#slot&gt; to pass context values directly to a slot without propagating context values to other components Add config :propagate_context_to_slots to restrict context propagatiion, optimizing diff tracking Add functions Context.copy_assign/3 , Context.maybe_copy_assign/3 and Context.maybe_copy_assign!/3 Add catalogue_test/1 macro to generate basic tests for catalogue examples and playgrounds Add module Surface.Catalogue.Examples to allow defining multiple stateless examples in a single module Support editing slot values as text in playgrounds (Catalogue) Fix context propagation in dynamic components Fix context propagation in recursive components New API for Slot arguments and generator (#613) Deprecations Deprecate &lt;InputContext&gt; in favor of declarative option from_context Slots (#613) Option :args has been deprecated, use slot arg: :string instead of slot args: [:name] slot arg: %{name: :string, age: number} instead of slot args: [:name, :age] Attribute for has been deprecated, use &lt;#slot {@header}&gt; instead of &lt;#slot for={@header}&gt; Attributes name and index have been deprecated, use &lt;#slot {col}&gt; instead of &lt;#slot name={&quot;col&quot;} index={index}&gt; Directive :args has been deprecated, use &lt;#slot {@default, name}&gt; instead of &lt;#slot :args={name: name}&gt; &lt;#slot {@default, name: name, age: age}&gt; instead of &lt;#slot :args={name: name, age: age}&gt; Breaking Changes Drop support for Elixir &lt; v1.12 Context values are no longer automatically propagated through slots. Components that need to pass values to the parent scope via slots must explicitly set propagate_context_to_slots: true in their configuration Slots (#613) New option :generator_prop use slot default, generator_prop: :items instead of slot default, args: [item: ^items] , associated prop :items must be of type :generator New attribute generator_value use &lt;#slot generator_value={item} /&gt; instead of &lt;#slot :args={item: item} /&gt; &lt;#template slot=&quot;slot_name&quot;&gt; has been removed in favor of &lt;:slot_name&gt; (#575)","ref":"changelog.html#v0-8-0-2022-09-01","title":"Changelog - v0.8.0 (2022-09-01)","type":"extras"},{"doc":"Support Elixir v1.14","ref":"changelog.html#v0-7-6-2022-09-05","title":"Changelog - v0.7.6 (2022-09-05)","type":"extras"},{"doc":"Support using vanilla phoenix function components with slots in surface templates","ref":"changelog.html#v0-7-5-2022-07-21","title":"Changelog - v0.7.5 (2022-07-21)","type":"extras"},{"doc":"Optimize the surface compiler for assets generation Improve support for JS hooks in umbrella projects (#591) Suppress Mix.Tasks.Format behaviour warning on Elixir &lt; v0.13","ref":"changelog.html#v0-7-4-2022-04-18","title":"Changelog - v0.7.4 (2022-04-18)","type":"extras"},{"doc":"Fix loading component prop's default values","ref":"changelog.html#v0-7-3-2022-03-18","title":"Changelog - v0.7.3 (2022-03-18)","type":"extras"},{"doc":"Support more extensions other than .js as colocated hooks ( jsx , ts and tsx ) (#576) Update the surface.init task to set up the catalogue to v0.4","ref":"changelog.html#v0-7-2-2022-03-17","title":"Changelog - v0.7.2 (2022-03-17)","type":"extras"},{"doc":"Fix wrong target handling in forms Fix setting @moduledoc false in catalogue examples (#565) Support Inputs' property for as string (#564)","ref":"changelog.html#v0-7-1-2022-02-17","title":"Changelog - v0.7.1 (2022-02-17)","type":"extras"},{"doc":"Support Liveview v0.17 Support rendering .sface templates for regular (dead) views (#543) Support passing properties to slots using the shorthand format, e.g. &lt;:col label=&quot;Name&quot;&gt; Add built-in formatter supporting integration with mix format (#535) New &lt;LiveComponent&gt; component to inject dynamic live components (#518) Optimize rendering of HTML class attributes literals so they can be treated as static text Add property for to &lt;#slot/&gt; so it can render the slot content directly (without using index )","ref":"changelog.html#v0-7-0-2022-01-13","title":"Changelog - v0.7.0 (2022-01-13)","type":"extras"},{"doc":"Add surface_formatter dependency to mix.exs when running mix surface.init (#507) Allow Inputs component inside the Field component (#492) Fix using context with external .sface templates (#511) Fix attribute name conversion (#512)","ref":"changelog.html#v0-6-1-2021-10-26","title":"Changelog - v0.6.1 (2021-10-26)","type":"extras"},{"doc":"Compatibility with Phoenix v1.6 and Liveview v0.16 New mix surface.init task Add support for function components Add support for dynamic function components via &lt;Component&gt; Add support for recursive function components Optimize change tracking for contexts Fix race condition when compiling tests Fix recompilation of used components","ref":"changelog.html#v0-6-0-2021-10-21","title":"Changelog - v0.6.0 (2021-10-21)","type":"extras"},{"doc":"Add property values to form inputs Handle doctype as text Improve error message when default_translator is not configured for ErrorTag (#449) Raise on invalid attribute/directive in &lt;#slot&gt; (#456) Raise error on {#case} without {#match} (#443) Raise on blocks without expression Fix error line on missing closing tag","ref":"changelog.html#v0-5-1-2021-07-13","title":"Changelog - v0.5.1 (2021-07-13)","type":"extras"},{"doc":"Add &lt;:slotname&gt; shorthand for &lt;#template slot=&quot;slotname&quot;&gt; Introduce block expressions for surface templates (e.g., {#if}..{/if} ) Introduce {#if} block expression with support for {#elseif} and {#else} sub blocks Introduce {#for} block expression with support for {#else} sub block Introduce {#unless} block expression Introduce new shorthand notation for dynamic attributes/props using the {... } tagged expression Introduce new shorthand notation for attribute assignment using the {= } tagged expression Support private comments using {!-- --} for comments that are not supposed to hit the browser Introduce s- prefix as an alternative to : for directives (i.e. s-if and :if are now equivalent) Introduce :values directive for generating multiple phx-value- attributes Added a convert task to aid migrating to the new syntax Evaluate literal attribute values at compile time instead of runtime Fix compile error when using single quotes as attribute value delimiters Add quote_surface/2 macro to generate Surface AST from template snippets. Breaking Changes Replace the sigil ~H with ~F to avoid conflict with HEEx Replace interpolation delimiters {{ and }} with { and } Remove support for interpolation inside &lt;style&gt;...&lt;/style&gt; and &lt;script&gt;...&lt;/script&gt; nodes ErrorTag: Renamed prop phx_feedback_for to feedback_for Slot directive :props has been renamed to :args Option :props for the slot/2 macro has been renamed to :args The use of &lt;template&gt; has been removed in favor of &lt;#template&gt; The use of &lt;slot&gt; has been removed in favor of &lt;#slot&gt; The use of &lt;If&gt; has been removed in favor of {#if}...{/if} The use of &lt;For&gt; has been removed in favor of {#for}...{/for} MacroComponent.eval_static_props!/3 evaluates and returns only props with option static: true Deprecations Support for passing non-string attribute values as literals (i.e. selected=true or tabindex=3 ) has been removed. Any non-string value should be passed as an expression (i.e. selected={true} )","ref":"changelog.html#v0-5-0-2021-06-17","title":"Changelog - v0.5.0 (2021-06-17)","type":"extras"},{"doc":"Fix warning on Phoenix Live View &gt;= 1.15.6","ref":"changelog.html#v0-4-1-2021-05-26","title":"Changelog - v0.4.1 (2021-05-26)","type":"extras"},{"doc":"Call render when defined in slotable components (#283) Support defining form fields as strings. Consequently, fields defined as literal strings will no longer be auto-converted to :atom and will keep the original value (#319) Deprecate auto-conversion of attribute values passed as string literals into atoms Do not encode HTML entities when passing attribute values as string literals (#323) Extract the Markdown macro component in its repository (#316) Renamed Surface.Components.Button to Surface.Components.Link.Button (#350)","ref":"changelog.html#v0-4-0-2021-05-01","title":"Changelog - v0.4.0 (2021-05-01)","type":"extras"},{"doc":"Warn if prop is required and has default value (#282) Warn if slot is required and has a fallback content (#296) Warn on LiveComponent with another LiveComponent as root Support escaped three double-quotes in Markdown content Improve Label component compatibility with Phoenix label/2 (#284) Update props according to new types (#297) Fix copying JS hooks multiple times (#294)","ref":"changelog.html#v0-3-2-2021-03-19","title":"Changelog - v0.3.2 (2021-03-19)","type":"extras"},{"doc":"Fix index.js generation when no hooks are available Fix loading hooks from dependencies Support &lt;Link&gt; with scheme (#273)","ref":"changelog.html#v0-3-1-2021-03-05","title":"Changelog - v0.3.1 (2021-03-05)","type":"extras"},{"doc":"Autoload JS hooks via new surface compiler (#271) New &lt;Link&gt; and &lt;Label&gt; implementation without depending on content_tag to allow receiving child components in slots (#264) Don't validate undefined assigns outside render (#263) Load subject's default props values before sending them to playgrounds","ref":"changelog.html#v0-3-0-2021-02-24","title":"Changelog - v0.3.0 (2021-02-24)","type":"extras"},{"doc":"Allow different catalogue options for examples and playgrounds","ref":"changelog.html#v0-2-1-2021-02-01","title":"Changelog - v0.2.1 (2021-02-01)","type":"extras"},{"doc":"Introduce new testing API using render_surface/1 Add experimental support to create examples and playgrounds for catalogues Raises compile error if slots are not declared Raises compile error on duplicate built-in assign Allow defining the assign name for slot through the :as option (#230) Implement the :show directive via hidden attribute (#244) Add new &lt;DateSelectComponent&gt; component Remove default value from Form method prop Reintroduce opts prop for the &lt;Select&gt; component Fix markdown syntax warning in &lt;Form&gt; docs Fix error when using :if + :props in slots (#224) Fix line offset when using single-line ~H variants (#246) Fix UnicodeConversionError when using string literals inside interpolation","ref":"changelog.html#v0-2-0-2021-01-27","title":"Changelog - v0.2.0 (2021-01-27)","type":"extras"},{"doc":"Add explicit props for the main opts of Checkbox, Select, MultipleSelect, FileInput and Form (#215). Add new slot_assigned?/1 macro to check if a slot has been filled in (#211). Fix attribute value encoding","ref":"changelog.html#v0-1-1-2020-11-28","title":"Changelog - v0.1.1 (2020-11-28)","type":"extras"},{"doc":"Update liveview to v0.15 Add new Surface.Components.Form.ErrorTag to render error messages in forms (#199). Disable validation for required props if :props is passed (#204)","ref":"changelog.html#v0-1-0-2020-11-23","title":"Changelog - v0.1.0 (2020-11-23)","type":"extras"},{"doc":"Update liveview to latest v0.15-dev (f986171) New wrapper components Surface.Components.{For, If} for when the :for and :if directives aren't sufficient (#184) Allow double braces within interpolation (#171) Add new Surface.Components.FieldContext to support form fields without wrapping divs (#172) Improve error message for unloaded modules (#174) Fix issue with :for modifiers on components (#176) Expose form instance as slot prop on Surface.Components.Form (#183) Don't initialize data assigns without default value (#195)","ref":"changelog.html#v0-1-0-rc-2-2020-11-04","title":"Changelog - v0.1.0-rc.2 (2020-11-04)","type":"extras"},{"doc":"Fix support for Elixir &gt;= v1.11 Update liveview to latest v0.15-dev (597c5dd) Add undefined assign check for Surface.{LiveComponent,Component,LiveView} New form controls wrappers: &lt;DateTimeSelect&gt; and &lt;TimeSelect&gt; . Force recompilation of the parent component after fixing errors on any of its children.","ref":"changelog.html#v0-1-0-rc-1-2020-10-21","title":"Changelog - v0.1.0-rc.1 (2020-10-21)","type":"extras"},{"doc":"Update LiveView to v0.15-dev (0f592a4). Make &lt;slot&gt; mandatory instead of inner_content . Add attribute index to &lt;slot&gt; to allow rendering individual named slot items. Rename macro property to prop . Remove macro context and add a &lt;Context&gt; component to be used instead. Rename directives :on-phx-[event] to :on-[event] . Add support for co-located template files using .sface suffix. Add Surface.init/1 to initialize internal assigns when not using Surface.LiveView . Add :props directive to pass dynamic props to a component. Add :attrs directive to pass dynamic attributes to a tag. Add new modifiers index and with_index for :for . Update html tag generation to remove the tag if it's value computes to nil . Add support for a transform/1 callback to allow components to manipulate its own node at compile-time. New form controls: &lt;Inputs&gt; , &lt;Checkbox&gt; , &lt;Select&gt; , &lt;MultipleSelect&gt; , &lt;HiddenInputs&gt; , &lt;FileInput&gt; and &lt;OptionsForSelect&gt; .","ref":"changelog.html#v0-1-0-rc-0-2020-10-06","title":"Changelog - v0.1.0-rc.0 (2020-10-06)","type":"extras"},{"doc":"New Markdown component New Link component New form components Form, Field, TextArea, Label, TextInput, RadioButton, HiddenInput, ColorInput, DateInput, DateTimeLocalInput, EmailInput, NumberInput, PasswordInput, RangeInput, SearchInput, TelephoneInput, TimeInput, UrlInput, Reset and Submit. Automatically define a required :id property for live components that implement handle_event/3 New config API for components Update LiveView to v0.13","ref":"changelog.html#v0-1-0-alpha-2-2020-06-09","title":"Changelog - v0.1.0-alpha.2 (2020-06-09)","type":"extras"},{"doc":"Add support for slots Add built-in LivePath and LiveRedirect components Drop automatic camel-to-kebab conversion for CSS class name Drop support for inner_content.() . Use inner_content.([]) instead Update LiveView to v0.11.1","ref":"changelog.html#v0-1-0-alpha-1-2020-04-13","title":"Changelog - v0.1.0-alpha.1 (2020-04-13)","type":"extras"},{"doc":"Initial alpha release","ref":"changelog.html#v0-1-0-alpha-0-2020-02-26","title":"Changelog - v0.1.0-alpha.0 (2020-02-26)","type":"extras"},{"doc":"Historically, most of the updates that require changes in your code, can be automatically done by mix surface.convert , however, as we move forward to unify the API with Liveview, some of the changes in v0.8 may require user intervention as the converter might not be able to automatically patch the project. For such cases, we adjusted the compiler to provide assertive warnings to help you with the migration process. The main changes of that kind are related to the context and slot APIs.","ref":"migrating.html","title":"Migrating from v0.7.x to v0.8.x","type":"extras"},{"doc":"The context API have been extended and fully redesigned to improve its use and make it more friendly for diff tracking. The compiler is able now to detect many cases where the use of contexts might impact performance and suggest one or more alternative approaches to achieve the same goal. We recommend you to carefully read each warning with care and follow the instructions that best suits your particular case. Aside from the warnings, the only breaking change is that context values are no longer automatically propagated through slots. Components that need to pass values to the parent scope via slots must explicitly set propagate_context_to_slots: true in config.exs : config :surface , :components , [ { Surface.Components.Form , propagate_context_to_slots : true } , ] The compiler will raise an error whenever it finds a component that can potentially propagate context values through slots. If you don't want to use contexts at all, you need to set propagate_context_to_slots to false to suppress the error for that component. NOTE: The following built-in Surface components are already configured to propagate context to slots: Surface.Components.Form, , Surface.Components.Form.Field , Surface.Components.Form.FieldContext and Surface.Components.Form.Inputs .","ref":"migrating.html#the-new-context-api","title":"Migrating from v0.7.x to v0.8.x - The new Context API","type":"extras"},{"doc":"The slot API for arguments and generators have changed to make it similar to Liveview. Rendering Slots Previously the reference was given in a combination of the for , name and index arguments. Now the slot reference is given as the first argument of the root property: &lt;#slot {@name} /&gt; . The converter doesn't update any &lt;#slot&gt; that has the index property. Slot argument(s) Previous versions of Surface only allowed the syntax slot default, args: [:index] and &lt;#slot arg={index: 10}&gt; , in other words we always required the argument to be a map. Now the argument can be any value and in :let we can pattern match more freely and be compatible with Liveview slots/components. Now the slot argument is given as the second argument of the root property: &lt;#slot {@name, argument} /&gt; . Slot generator The changes to generator are too complex for the converter to handle, the compiler errors/warnings will guide you through the needed changes. # before prop items , :list slot cols , args : [ item : ^ items ] ~F&quot;&quot;&quot; {#for item &lt;- @items} &lt;#slot :args={item: item} /&gt; {/for} &quot;&quot;&quot; # after prop items , :generator slot cols , generator_prop : :items ~F&quot;&quot;&quot; {#for item &lt;- @items} &lt;#slot generator_value={item} /&gt; {/for} &quot;&quot;&quot;","ref":"migrating.html#the-new-slot-api","title":"Migrating from v0.7.x to v0.8.x - The new Slot API","type":"extras"},{"doc":"This guide provides detailed instructions on how to run the built-in converter to automatically apply required changes to your project's source code to make it compatible with Surface v0.8 . NOTE: The current converter was designed to run against projects depending on Surface &gt;= v0.7.x . If you're using an older version, you should first update it to each one of the previous versions all the way to v0.7 . See: previous versions Limitations of the converter By design, the converter doesn't touch Surface code inside documentation or macro components. If you have any code written inside &lt;!-- --&gt; or &lt;#Raw&gt;...&lt;/#Raw&gt; , you need to convert it manually. Running the converter on a project that has already been converted may generate invalid code. If anything goes wrong with the conversion, make sure you revert the changes before running it again.","ref":"migrating.html#running-mix-surface-convert","title":"Migrating from v0.7.x to v0.8.x - Running mix surface.convert","type":"extras"},{"doc":"Make sure you have committed your work or have a proper backup before running the converter. It may touch a lot of files so it's recommended to have a safe way to rollback the changes in case anything goes wrong. Check your dependencies. In case your project depends on a library using an older Surface version, it might start emitting warnings or even fail to compile after updating Surface. If that's the case, please consider running the converter against it and submitting a PR with the updated code. The steps to convert a dependency are the same described in this guide. Check that your .formatter has the configuration about the components you want to convert. The plugin documentation has the instructions.","ref":"migrating.html#before-converting-the-project","title":"Migrating from v0.7.x to v0.8.x - Before converting the project","type":"extras"},{"doc":"Update mix.exs to use the new version: defp deps do [ { :surface , &quot;~&gt; 0.8.0&quot; } , ... ] end Compile the dependencies: mix clean &amp;&amp; mix deps.get &amp;&amp; mix deps.compile Compile the project and fix all compilation errors, changes to the slot generator API are not handled by the converter. mix compile Run the converter: mix surface.convert Compile the converted project: mix compile","ref":"migrating.html#steps-to-run-the-converter","title":"Migrating from v0.7.x to v0.8.x - Steps to run the converter","type":"extras"},{"doc":"Subject Examples (Old syntax -&gt; New syntax) Slot Entry &lt;#template&gt; -&gt; &lt;:default&gt; Slot Entry &lt;#template slot=&quot;header&quot;&gt; -&gt; &lt;:header&gt; &lt;#slot for&gt; &lt;#slot for={@name}&gt; -&gt; &lt;#slot {@name}&gt; &lt;#slot name&gt; &lt;#slot name=&quot;name&quot;&gt; -&gt; &lt;#slot {@name}&gt; &lt;#slot :args&gt; &lt;#slot :args={name: &quot;Joe&quot;, age: &quot;32&quot;}&gt; -&gt; &lt;#slot {@default, name: &quot;Joe&quot;, age: 35}&gt;","ref":"migrating.html#expected-changes","title":"Migrating from v0.7.x to v0.8.x - Expected changes","type":"extras"},{"doc":"In case you run into any trouble while running the converter, please open an issue at https://github.com/surface-ui/surface/issues/ providing detailed information about the problem, including the error message (if any) and a snippet of the related code.","ref":"migrating.html#reporting-issues","title":"Migrating from v0.7.x to v0.8.x - Reporting issues","type":"extras"},{"doc":"Migrating from v0.6.x to v0.7.x No converter was needed. Migrating from v0.5.x to v0.6.x Surface v0.6.x relies on the Liveview features available since v0.16 . The main change from the user perspective is that the stateless Surface.Component now is built on top of Phoenix.Component instead of Phoenix.LiveComponent . This means the mount/1 , preload/1 and update/2 callbacks are no longer available. If you initialize any assign or compute any value using those callbacks, you need to replace them with one of the new assign helpers . Migrating from v0.4.x to v0.5.x Surface v0.5.0 introduces a new syntax which requires migrating components written in previous versions. In order to make the migration process as smooth as possible, Surface v0.5.x ships with a converter that can automatically translate the old syntax into the new one.","ref":"migrating.html#previous-versions","title":"Migrating from v0.7.x to v0.8.x - Previous versions","type":"extras"},{"doc":"Copyright (c) 2019 Marlus Saraiva Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"MIT License","type":"extras"}]